#!/bin/sh

type=Au102_180
cwd=`pwd`
queue=prod
time=60
nodes=512
mode=vn
mapping=ZYXT
# mapfile=BGMAP_8x8x8x8
# mapping=$mapfile
job=${type}_${nodes}_${mode}_${mapping}_ibm
input=Au_cluster.py
pos=Au102_revised.xyz
scratch=/intrepid-fs0/users/naromero/persistent

rm -rf $scratch/$job
mkdir $scratch/$job
cp $input $scratch/$job
# cp $mapfile $scratch/$job
cp $pos $scratch/$job
cd $scratch/$job

# MAIN UNINSTRUMENTED 
qsub -A Gpaw -n $nodes -t $time -q $queue --mode $mode --env DCMF_EAGER=12000000:BG_MAPPING=$mapping:MPIRUN_ENABLE_TTY_REPORTING=0:OMP_NUM_THREADS=1:GPAW_SETUP_PATH=$GPAW_SETUP_PATH:PYTHONPATH=/home/naromero/ase:/home/naromero/gpaw:$PYTHONPATH:LD_LIBRARY_PATH=$CN_LD_LIBRARY_PATH /home/naromero/gpaw/build/bin.linux-ppc64-2.6/gpaw-python ./$input --sl_inverse_cholesky=4,4,64,4 --sl_diagonalize=4,4,64,4 --domain-decomposition=8,8,8 --state-parallelization=4 --gpaw=blacs=1,usenewlfc=1,usenewtci=1

