from ase import *
from gpaw import GPAW
from gpaw.eigensolvers.rmm_diis import RMM_DIIS
a = molecule('N2')
a.center(vacuum=3)
c = GPAW(nbands=8,
                  eigensolver=RMM_DIIS(keep_htpsit=False),
                  width=0.01)
a.set_calculator(c)

# a.get_potential_energy()
dyn= LBFGS(a, logfile='qn.log', trajectory='qn.traj', restart='qn.pckl')
dyn.run(fmax=0.05)
