#line 1 "numpy/core/src/umath_loops.inc.src"

/*
 *****************************************************************************
 **       This file was autogenerated from a template  DO NOT EDIT!!!!      **
 **       Changes should be made to the original source (.src) file         **
 *****************************************************************************
 */

#line 1
/* -*- c -*- */

/*
 *****************************************************************************
 **                             UFUNC LOOPS                                 **
 *****************************************************************************
 */

#define OUTPUT_LOOP\
    char *op1 = args[1];\
    intp os1 = steps[1];\
    intp n = dimensions[0];\
    intp i;\
    for(i = 0; i < n; i++, op1 += os1)

#define UNARY_LOOP\
    char *ip1 = args[0], *op1 = args[1];\
    intp is1 = steps[0], os1 = steps[1];\
    intp n = dimensions[0];\
    intp i;\
    for(i = 0; i < n; i++, ip1 += is1, op1 += os1)

#define UNARY_LOOP_TWO_OUT\
    char *ip1 = args[0], *op1 = args[1], *op2 = args[2];\
    intp is1 = steps[0], os1 = steps[1], os2 = steps[2];\
    intp n = dimensions[0];\
    intp i;\
    for(i = 0; i < n; i++, ip1 += is1, op1 += os1, op2 += os2)

#define BINARY_LOOP\
    char *ip1 = args[0], *ip2 = args[1], *op1 = args[2];\
    intp is1 = steps[0], is2 = steps[1], os1 = steps[2];\
    intp n = dimensions[0];\
    intp i;\
    for(i = 0; i < n; i++, ip1 += is1, ip2 += is2, op1 += os1)

#define BINARY_LOOP_TWO_OUT\
    char *ip1 = args[0], *ip2 = args[1], *op1 = args[2], *op2 = args[3];\
    intp is1 = steps[0], is2 = steps[1], os1 = steps[2], os2 = steps[3];\
    intp n = dimensions[0];\
    intp i;\
    for(i = 0; i < n; i++, ip1 += is1, ip2 += is2, op1 += os1, op2 += os2)

/******************************************************************************
 **                          GENERIC FLOAT LOOPS                             **
 *****************************************************************************/


typedef float floatUnaryFunc(float x);
typedef double doubleUnaryFunc(double x);
typedef longdouble longdoubleUnaryFunc(longdouble x);
typedef float floatBinaryFunc(float x, float y);
typedef double doubleBinaryFunc(double x, double y);
typedef longdouble longdoubleBinaryFunc(longdouble x, longdouble y);


/*UFUNC_API*/
static void
PyUFunc_f_f(char **args, intp *dimensions, intp *steps, void *func)
{
    floatUnaryFunc *f = (floatUnaryFunc *)func;
    UNARY_LOOP {
        const float in1 = *(float *)ip1;
        *(float *)op1 = f(in1);
    }
}

/*UFUNC_API*/
static void
PyUFunc_f_f_As_d_d(char **args, intp *dimensions, intp *steps, void *func)
{
    doubleUnaryFunc *f = (doubleUnaryFunc *)func;
    UNARY_LOOP {
        const float in1 = *(float *)ip1;
        *(float *)op1 = (float)f((double)in1);
    }
}

/*UFUNC_API*/
static void
PyUFunc_ff_f(char **args, intp *dimensions, intp *steps, void *func)
{
    floatBinaryFunc *f = (floatBinaryFunc *)func;
    BINARY_LOOP {
        float in1 = *(float *)ip1;
        float in2 = *(float *)ip2;
        *(float *)op1 = f(in1, in2);
    }
}

/*UFUNC_API*/
static void
PyUFunc_ff_f_As_dd_d(char **args, intp *dimensions, intp *steps, void *func)
{
    doubleBinaryFunc *f = (doubleBinaryFunc *)func;
    BINARY_LOOP {
        float in1 = *(float *)ip1;
        float in2 = *(float *)ip2;
        *(float *)op1 = (double)f((double)in1, (double)in2);
    }
}

/*UFUNC_API*/
static void
PyUFunc_d_d(char **args, intp *dimensions, intp *steps, void *func)
{
    doubleUnaryFunc *f = (doubleUnaryFunc *)func;
    UNARY_LOOP {
        double in1 = *(double *)ip1;
        *(double *)op1 = f(in1);
    }
}

/*UFUNC_API*/
static void
PyUFunc_dd_d(char **args, intp *dimensions, intp *steps, void *func)
{
    doubleBinaryFunc *f = (doubleBinaryFunc *)func;
    BINARY_LOOP {
        double in1 = *(double *)ip1;
        double in2 = *(double *)ip2;
        *(double *)op1 = f(in1, in2);
    }
}

/*UFUNC_API*/
static void
PyUFunc_g_g(char **args, intp *dimensions, intp *steps, void *func)
{
    longdoubleUnaryFunc *f = (longdoubleUnaryFunc *)func;
    UNARY_LOOP {
        longdouble in1 = *(longdouble *)ip1;
        *(longdouble *)op1 = f(in1);
    }
}

/*UFUNC_API*/
static void
PyUFunc_gg_g(char **args, intp *dimensions, intp *steps, void *func)
{
    longdoubleBinaryFunc *f = (longdoubleBinaryFunc *)func;
    BINARY_LOOP {
        longdouble in1 = *(longdouble *)ip1;
        longdouble in2 = *(longdouble *)ip2;
        *(longdouble *)op1 = f(in1, in2);
    }
}



/******************************************************************************
 **                          GENERIC COMPLEX LOOPS                           **
 *****************************************************************************/


typedef void cdoubleUnaryFunc(cdouble *x, cdouble *r);
typedef void cfloatUnaryFunc(cfloat *x, cfloat *r);
typedef void clongdoubleUnaryFunc(clongdouble *x, clongdouble *r);
typedef void cdoubleBinaryFunc(cdouble *x, cdouble *y, cdouble *r);
typedef void cfloatBinaryFunc(cfloat *x, cfloat *y, cfloat *r);
typedef void clongdoubleBinaryFunc(clongdouble *x, clongdouble *y,
                                   clongdouble *r);

/*UFUNC_API*/
static void
PyUFunc_F_F(char **args, intp *dimensions, intp *steps, void *func)
{
    cfloatUnaryFunc *f = (cfloatUnaryFunc *)func;
    UNARY_LOOP {
        cfloat in1 = *(cfloat *)ip1;
        cfloat *out = (cfloat *)op1;
        f(&in1, out);
    }
}

/*UFUNC_API*/
static void
PyUFunc_F_F_As_D_D(char **args, intp *dimensions, intp *steps, void *func)
{
    cdoubleUnaryFunc *f = (cdoubleUnaryFunc *)func;
    UNARY_LOOP {
        cdouble tmp, out;
        tmp.real = (double)((float *)ip1)[0];
        tmp.imag = (double)((float *)ip1)[1];
        f(&tmp, &out);
        ((float *)op1)[0] = (float)out.real;
        ((float *)op1)[1] = (float)out.imag;
    }
}

/*UFUNC_API*/
static void
PyUFunc_FF_F(char **args, intp *dimensions, intp *steps, void *func)
{
    cfloatBinaryFunc *f = (cfloatBinaryFunc *)func;
    BINARY_LOOP {
        cfloat in1 = *(cfloat *)ip1;
        cfloat in2 = *(cfloat *)ip2;
        cfloat *out = (cfloat *)op1;
        f(&in1, &in2, out);
    }
}

/*UFUNC_API*/
static void
PyUFunc_FF_F_As_DD_D(char **args, intp *dimensions, intp *steps, void *func)
{
    cdoubleBinaryFunc *f = (cdoubleBinaryFunc *)func;
    BINARY_LOOP {
        cdouble tmp1, tmp2, out;
        tmp1.real = (double)((float *)ip1)[0];
        tmp1.imag = (double)((float *)ip1)[1];
        tmp2.real = (double)((float *)ip2)[0];
        tmp2.imag = (double)((float *)ip2)[1];
        f(&tmp1, &tmp2, &out);
        ((float *)op1)[0] = (float)out.real;
        ((float *)op1)[1] = (float)out.imag;
    }
}

/*UFUNC_API*/
static void
PyUFunc_D_D(char **args, intp *dimensions, intp *steps, void *func)
{
    cdoubleUnaryFunc *f = (cdoubleUnaryFunc *)func;
    UNARY_LOOP {
        cdouble in1 = *(cdouble *)ip1;
        cdouble *out = (cdouble *)op1;
        f(&in1, out);
    }
}

/*UFUNC_API*/
static void
PyUFunc_DD_D(char **args, intp *dimensions, intp *steps, void *func)
{
    cdoubleBinaryFunc *f = (cdoubleBinaryFunc *)func;
    BINARY_LOOP {
        cdouble in1 = *(cdouble *)ip1;
        cdouble in2 = *(cdouble *)ip2;
        cdouble *out = (cdouble *)op1;
        f(&in1, &in2, out);
    }
}

/*UFUNC_API*/
static void
PyUFunc_G_G(char **args, intp *dimensions, intp *steps, void *func)
{
    clongdoubleUnaryFunc *f = (clongdoubleUnaryFunc *)func;
    UNARY_LOOP {
        clongdouble in1 = *(clongdouble *)ip1;
        clongdouble *out = (clongdouble *)op1;
        f(&in1, out);
    }
}

/*UFUNC_API*/
static void
PyUFunc_GG_G(char **args, intp *dimensions, intp *steps, void *func)
{
    clongdoubleBinaryFunc *f = (clongdoubleBinaryFunc *)func;
    BINARY_LOOP {
        clongdouble in1 = *(clongdouble *)ip1;
        clongdouble in2 = *(clongdouble *)ip2;
        clongdouble *out = (clongdouble *)op1;
        f(&in1, &in2, out);
    }
}


/******************************************************************************
 **                         GENERIC OBJECT lOOPS                             **
 *****************************************************************************/

/*UFUNC_API*/
static void
PyUFunc_O_O(char **args, intp *dimensions, intp *steps, void *func)
{
    unaryfunc f = (unaryfunc)func;
    UNARY_LOOP {
        PyObject *in1 = *(PyObject **)ip1;
        PyObject **out = (PyObject **)op1;
        PyObject *ret = f(in1);
        if ((ret == NULL) || PyErr_Occurred()) {
            return;
        }
        Py_XDECREF(*out);
        *out = ret;
    }
}

/*UFUNC_API*/
static void
PyUFunc_O_O_method(char **args, intp *dimensions, intp *steps, void *func)
{
    char *meth = (char *)func;
    UNARY_LOOP {
        PyObject *in1 = *(PyObject **)ip1;
        PyObject **out = (PyObject **)op1;
        PyObject *ret = PyObject_CallMethod(in1, meth, NULL);
        if (ret == NULL) {
            return;
        }
        Py_XDECREF(*out);
        *out = ret;
    }
}

/*UFUNC_API*/
static void
PyUFunc_OO_O(char **args, intp *dimensions, intp *steps, void *func)
{
    binaryfunc f = (binaryfunc)func;
    BINARY_LOOP {
        PyObject *in1 = *(PyObject **)ip1;
        PyObject *in2 = *(PyObject **)ip2;
        PyObject **out = (PyObject **)op1;
        PyObject *ret = f(in1, in2);
        if (PyErr_Occurred()) {
            return;
        }
        Py_XDECREF(*out);
        *out = ret;
    }
}

/*UFUNC_API*/
static void
PyUFunc_OO_O_method(char **args, intp *dimensions, intp *steps, void *func)
{
    char *meth = (char *)func;
    BINARY_LOOP {
        PyObject *in1 = *(PyObject **)ip1;
        PyObject *in2 = *(PyObject **)ip2;
        PyObject **out = (PyObject **)op1;
        PyObject *ret = PyObject_CallMethod(in1, meth, "(O)", in2);
        if (ret == NULL) {
            return;
        }
        Py_XDECREF(*out);
        *out = ret;
    }
}

/*
 * A general-purpose ufunc that deals with general-purpose Python callable.
 * func is a structure with nin, nout, and a Python callable function
 */

/*UFUNC_API*/
static void
PyUFunc_On_Om(char **args, intp *dimensions, intp *steps, void *func)
{
    intp n =  dimensions[0];
    PyUFunc_PyFuncData *data = (PyUFunc_PyFuncData *)func;
    int nin = data->nin;
    int nout = data->nout;
    PyObject *tocall = data->callable;
    char *ptrs[NPY_MAXARGS];
    PyObject *arglist, *result;
    PyObject *in, **op;
    intp i, j, ntot;

    ntot = nin+nout;

    for(j = 0; j < ntot; j++) {
        ptrs[j] = args[j];
    }
    for(i = 0; i < n; i++) {
        arglist = PyTuple_New(nin);
        if (arglist == NULL) {
            return;
        }
        for(j = 0; j < nin; j++) {
            in = *((PyObject **)ptrs[j]);
            if (in == NULL) {
                Py_DECREF(arglist);
                return;
            }
            PyTuple_SET_ITEM(arglist, j, in);
            Py_INCREF(in);
        }
        result = PyEval_CallObject(tocall, arglist);
        Py_DECREF(arglist);
        if (result == NULL) {
            return;
        }
        if PyTuple_Check(result) {
            if (nout != PyTuple_Size(result)) {
                Py_DECREF(result);
                return;
            }
            for(j = 0; j < nout; j++) {
                op = (PyObject **)ptrs[j+nin];
                Py_XDECREF(*op);
                *op = PyTuple_GET_ITEM(result, j);
                Py_INCREF(*op);
            }
            Py_DECREF(result);
        }
        else {
            op = (PyObject **)ptrs[nin];
            Py_XDECREF(*op);
            *op = result;
        }
        for(j = 0; j < ntot; j++) {
            ptrs[j] += steps[j];
        }
    }
}

/*
 *****************************************************************************
 **                             BOOLEAN LOOPS                               **
 *****************************************************************************
 */

#define BOOL_invert BOOL_logical_not
#define BOOL_negative BOOL_logical_not
#define BOOL_add BOOL_logical_or
#define BOOL_bitwise_and BOOL_logical_and
#define BOOL_bitwise_or BOOL_logical_or
#define BOOL_bitwise_xor BOOL_logical_xor
#define BOOL_multiply BOOL_logical_and
#define BOOL_subtract BOOL_logical_xor
#define BOOL_fmax BOOL_maximum
#define BOOL_fmin BOOL_minimum

#line 435

static void
BOOL_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        Bool in1 = *((Bool *)ip1) != 0;
        Bool in2 = *((Bool *)ip2) != 0;
        *((Bool *)op1)= in1 == in2;
    }
}

#line 435

static void
BOOL_not_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        Bool in1 = *((Bool *)ip1) != 0;
        Bool in2 = *((Bool *)ip2) != 0;
        *((Bool *)op1)= in1 != in2;
    }
}

#line 435

static void
BOOL_greater(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        Bool in1 = *((Bool *)ip1) != 0;
        Bool in2 = *((Bool *)ip2) != 0;
        *((Bool *)op1)= in1 > in2;
    }
}

#line 435

static void
BOOL_greater_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        Bool in1 = *((Bool *)ip1) != 0;
        Bool in2 = *((Bool *)ip2) != 0;
        *((Bool *)op1)= in1 >= in2;
    }
}

#line 435

static void
BOOL_less(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        Bool in1 = *((Bool *)ip1) != 0;
        Bool in2 = *((Bool *)ip2) != 0;
        *((Bool *)op1)= in1 < in2;
    }
}

#line 435

static void
BOOL_less_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        Bool in1 = *((Bool *)ip1) != 0;
        Bool in2 = *((Bool *)ip2) != 0;
        *((Bool *)op1)= in1 <= in2;
    }
}

#line 435

static void
BOOL_logical_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        Bool in1 = *((Bool *)ip1) != 0;
        Bool in2 = *((Bool *)ip2) != 0;
        *((Bool *)op1)= in1 && in2;
    }
}

#line 435

static void
BOOL_logical_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        Bool in1 = *((Bool *)ip1) != 0;
        Bool in2 = *((Bool *)ip2) != 0;
        *((Bool *)op1)= in1 || in2;
    }
}


static void
BOOL_logical_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        Bool in1 = *((Bool *)ip1) != 0;
        Bool in2 = *((Bool *)ip2) != 0;
        *((Bool *)op1)= (in1 && !in2) || (!in1 && in2);
    }
}

#line 461
static void
BOOL_maximum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        Bool in1 = *((Bool *)ip1) != 0;
        Bool in2 = *((Bool *)ip2) != 0;
        *((Bool *)op1) = (in1 > in2) ? in1 : in2;
    }
}

#line 461
static void
BOOL_minimum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        Bool in1 = *((Bool *)ip1) != 0;
        Bool in2 = *((Bool *)ip2) != 0;
        *((Bool *)op1) = (in1 < in2) ? in1 : in2;
    }
}


#line 476
static void
BOOL_absolute(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        Bool in1 = *(Bool *)ip1;
        *((Bool *)op1) = in1 != 0;
    }
}

#line 476
static void
BOOL_logical_not(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        Bool in1 = *(Bool *)ip1;
        *((Bool *)op1) = in1 == 0;
    }
}


static void
BOOL_ones_like(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    OUTPUT_LOOP {
        *((Bool *)op1) = 1;
    }
}


/*
 *****************************************************************************
 **                           INTEGER LOOPS
 *****************************************************************************
 */

#line 506

#line 512

#define BYTE_floor_divide BYTE_divide
#define BYTE_fmax BYTE_maximum
#define BYTE_fmin BYTE_minimum

static void
BYTE_ones_like(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    OUTPUT_LOOP {
        *((byte *)op1) = 1;
    }
}

static void
BYTE_square(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const byte in1 = *(byte *)ip1;
        *((byte *)op1) = in1*in1;
    }
}

static void
BYTE_reciprocal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const byte in1 = *(byte *)ip1;
        *((byte *)op1) = (byte)(1.0/in1);
    }
}

static void
BYTE_conjugate(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const byte in1 = *(byte *)ip1;
        *((byte *)op1) = in1;
    }
}

static void
BYTE_negative(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const byte in1 = *(byte *)ip1;
        *((byte *)op1) = (byte)(-(byte)in1);
    }
}

static void
BYTE_logical_not(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const byte in1 = *(byte *)ip1;
        *((Bool *)op1) = !in1;
    }
}

static void
BYTE_invert(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const byte in1 = *(byte *)ip1;
        *((byte *)op1) = ~in1;
    }
}

#line 585
static void
BYTE_add(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        *((byte *)op1) = in1 + in2;
    }
}

#line 585
static void
BYTE_subtract(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        *((byte *)op1) = in1 - in2;
    }
}

#line 585
static void
BYTE_multiply(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        *((byte *)op1) = in1 * in2;
    }
}

#line 585
static void
BYTE_bitwise_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        *((byte *)op1) = in1 & in2;
    }
}

#line 585
static void
BYTE_bitwise_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        *((byte *)op1) = in1 | in2;
    }
}

#line 585
static void
BYTE_bitwise_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        *((byte *)op1) = in1 ^ in2;
    }
}

#line 585
static void
BYTE_left_shift(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        *((byte *)op1) = in1 << in2;
    }
}

#line 585
static void
BYTE_right_shift(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        *((byte *)op1) = in1 >> in2;
    }
}


#line 601
static void
BYTE_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        *((Bool *)op1) = in1 == in2;
    }
}

#line 601
static void
BYTE_not_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        *((Bool *)op1) = in1 != in2;
    }
}

#line 601
static void
BYTE_greater(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        *((Bool *)op1) = in1 > in2;
    }
}

#line 601
static void
BYTE_greater_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        *((Bool *)op1) = in1 >= in2;
    }
}

#line 601
static void
BYTE_less(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        *((Bool *)op1) = in1 < in2;
    }
}

#line 601
static void
BYTE_less_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        *((Bool *)op1) = in1 <= in2;
    }
}

#line 601
static void
BYTE_logical_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        *((Bool *)op1) = in1 && in2;
    }
}

#line 601
static void
BYTE_logical_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        *((Bool *)op1) = in1 || in2;
    }
}


static void
BYTE_logical_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        *((Bool *)op1)= (in1 && !in2) || (!in1 && in2);
    }
}

#line 626
static void
BYTE_maximum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        *((byte *)op1) = (in1 > in2) ? in1 : in2;
    }
}

#line 626
static void
BYTE_minimum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        *((byte *)op1) = (in1 < in2) ? in1 : in2;
    }
}


static void
BYTE_true_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((float *)op1) = 0;
        }
        else {
            *((float *)op1) = (float)in1 / (float)in2;
        }
    }
}

static void
BYTE_power(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1 = (float)*(byte *)ip1;
        const float in2 = (float)*(byte *)ip2;
        *((byte *)op1) = (byte) pow(in1, in2);
    }
}

static void
BYTE_fmod(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((byte *)op1) = 0;
        }
        else {
            *((byte *)op1)= in1 % in2;
        }

    }
}


#line 512

#define UBYTE_floor_divide UBYTE_divide
#define UBYTE_fmax UBYTE_maximum
#define UBYTE_fmin UBYTE_minimum

static void
UBYTE_ones_like(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    OUTPUT_LOOP {
        *((ubyte *)op1) = 1;
    }
}

static void
UBYTE_square(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        *((ubyte *)op1) = in1*in1;
    }
}

static void
UBYTE_reciprocal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        *((ubyte *)op1) = (ubyte)(1.0/in1);
    }
}

static void
UBYTE_conjugate(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        *((ubyte *)op1) = in1;
    }
}

static void
UBYTE_negative(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        *((ubyte *)op1) = (ubyte)(-(byte)in1);
    }
}

static void
UBYTE_logical_not(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        *((Bool *)op1) = !in1;
    }
}

static void
UBYTE_invert(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        *((ubyte *)op1) = ~in1;
    }
}

#line 585
static void
UBYTE_add(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        *((ubyte *)op1) = in1 + in2;
    }
}

#line 585
static void
UBYTE_subtract(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        *((ubyte *)op1) = in1 - in2;
    }
}

#line 585
static void
UBYTE_multiply(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        *((ubyte *)op1) = in1 * in2;
    }
}

#line 585
static void
UBYTE_bitwise_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        *((ubyte *)op1) = in1 & in2;
    }
}

#line 585
static void
UBYTE_bitwise_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        *((ubyte *)op1) = in1 | in2;
    }
}

#line 585
static void
UBYTE_bitwise_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        *((ubyte *)op1) = in1 ^ in2;
    }
}

#line 585
static void
UBYTE_left_shift(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        *((ubyte *)op1) = in1 << in2;
    }
}

#line 585
static void
UBYTE_right_shift(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        *((ubyte *)op1) = in1 >> in2;
    }
}


#line 601
static void
UBYTE_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        *((Bool *)op1) = in1 == in2;
    }
}

#line 601
static void
UBYTE_not_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        *((Bool *)op1) = in1 != in2;
    }
}

#line 601
static void
UBYTE_greater(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        *((Bool *)op1) = in1 > in2;
    }
}

#line 601
static void
UBYTE_greater_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        *((Bool *)op1) = in1 >= in2;
    }
}

#line 601
static void
UBYTE_less(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        *((Bool *)op1) = in1 < in2;
    }
}

#line 601
static void
UBYTE_less_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        *((Bool *)op1) = in1 <= in2;
    }
}

#line 601
static void
UBYTE_logical_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        *((Bool *)op1) = in1 && in2;
    }
}

#line 601
static void
UBYTE_logical_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        *((Bool *)op1) = in1 || in2;
    }
}


static void
UBYTE_logical_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        *((Bool *)op1)= (in1 && !in2) || (!in1 && in2);
    }
}

#line 626
static void
UBYTE_maximum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        *((ubyte *)op1) = (in1 > in2) ? in1 : in2;
    }
}

#line 626
static void
UBYTE_minimum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        *((ubyte *)op1) = (in1 < in2) ? in1 : in2;
    }
}


static void
UBYTE_true_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((float *)op1) = 0;
        }
        else {
            *((float *)op1) = (float)in1 / (float)in2;
        }
    }
}

static void
UBYTE_power(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1 = (float)*(ubyte *)ip1;
        const float in2 = (float)*(ubyte *)ip2;
        *((ubyte *)op1) = (ubyte) pow(in1, in2);
    }
}

static void
UBYTE_fmod(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((ubyte *)op1) = 0;
        }
        else {
            *((ubyte *)op1)= in1 % in2;
        }

    }
}



static void
UBYTE_absolute(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        *((ubyte *)op1) = in1;
    }
}

static void
BYTE_absolute(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const byte in1 = *(byte *)ip1;
        *((byte *)op1) = (in1 >= 0) ? in1 : -in1;
    }
}

static void
UBYTE_sign(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        *((ubyte *)op1) = in1 > 0 ? 1 : 0;
    }
}

static void
BYTE_sign(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const byte in1 = *(byte *)ip1;
        *((byte *)op1) = in1 > 0 ? 1 : (in1 < 0 ? -1 : 0);
    }
}

static void
BYTE_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((byte *)op1) = 0;
        }
        else if (((in1 > 0) != (in2 > 0)) && (in1 % in2 != 0)) {
            *((byte *)op1) = in1/in2 - 1;
        }
        else {
            *((byte *)op1) = in1/in2;
        }
    }
}

static void
UBYTE_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((ubyte *)op1) = 0;
        }
        else {
            *((ubyte *)op1)= in1/in2;
        }
    }
}

static void
BYTE_remainder(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const byte in1 = *(byte *)ip1;
        const byte in2 = *(byte *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((byte *)op1) = 0;
        }
        else {
            /* handle mixed case the way Python does */
            const byte rem = in1 % in2;
            if ((in1 > 0) == (in2 > 0) || rem == 0) {
                *((byte *)op1) = rem;
            }
            else {
                *((byte *)op1) = rem + in2;
            }
        }
    }
}

static void
UBYTE_remainder(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ubyte in1 = *(ubyte *)ip1;
        const ubyte in2 = *(ubyte *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((byte *)op1) = 0;
        }
        else {
            *((byte *)op1) = in1 % in2;
        }
    }
}


#line 506

#line 512

#define SHORT_floor_divide SHORT_divide
#define SHORT_fmax SHORT_maximum
#define SHORT_fmin SHORT_minimum

static void
SHORT_ones_like(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    OUTPUT_LOOP {
        *((short *)op1) = 1;
    }
}

static void
SHORT_square(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const short in1 = *(short *)ip1;
        *((short *)op1) = in1*in1;
    }
}

static void
SHORT_reciprocal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const short in1 = *(short *)ip1;
        *((short *)op1) = (short)(1.0/in1);
    }
}

static void
SHORT_conjugate(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const short in1 = *(short *)ip1;
        *((short *)op1) = in1;
    }
}

static void
SHORT_negative(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const short in1 = *(short *)ip1;
        *((short *)op1) = (short)(-(short)in1);
    }
}

static void
SHORT_logical_not(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const short in1 = *(short *)ip1;
        *((Bool *)op1) = !in1;
    }
}

static void
SHORT_invert(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const short in1 = *(short *)ip1;
        *((short *)op1) = ~in1;
    }
}

#line 585
static void
SHORT_add(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        *((short *)op1) = in1 + in2;
    }
}

#line 585
static void
SHORT_subtract(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        *((short *)op1) = in1 - in2;
    }
}

#line 585
static void
SHORT_multiply(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        *((short *)op1) = in1 * in2;
    }
}

#line 585
static void
SHORT_bitwise_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        *((short *)op1) = in1 & in2;
    }
}

#line 585
static void
SHORT_bitwise_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        *((short *)op1) = in1 | in2;
    }
}

#line 585
static void
SHORT_bitwise_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        *((short *)op1) = in1 ^ in2;
    }
}

#line 585
static void
SHORT_left_shift(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        *((short *)op1) = in1 << in2;
    }
}

#line 585
static void
SHORT_right_shift(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        *((short *)op1) = in1 >> in2;
    }
}


#line 601
static void
SHORT_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        *((Bool *)op1) = in1 == in2;
    }
}

#line 601
static void
SHORT_not_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        *((Bool *)op1) = in1 != in2;
    }
}

#line 601
static void
SHORT_greater(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        *((Bool *)op1) = in1 > in2;
    }
}

#line 601
static void
SHORT_greater_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        *((Bool *)op1) = in1 >= in2;
    }
}

#line 601
static void
SHORT_less(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        *((Bool *)op1) = in1 < in2;
    }
}

#line 601
static void
SHORT_less_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        *((Bool *)op1) = in1 <= in2;
    }
}

#line 601
static void
SHORT_logical_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        *((Bool *)op1) = in1 && in2;
    }
}

#line 601
static void
SHORT_logical_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        *((Bool *)op1) = in1 || in2;
    }
}


static void
SHORT_logical_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        *((Bool *)op1)= (in1 && !in2) || (!in1 && in2);
    }
}

#line 626
static void
SHORT_maximum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        *((short *)op1) = (in1 > in2) ? in1 : in2;
    }
}

#line 626
static void
SHORT_minimum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        *((short *)op1) = (in1 < in2) ? in1 : in2;
    }
}


static void
SHORT_true_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((float *)op1) = 0;
        }
        else {
            *((float *)op1) = (float)in1 / (float)in2;
        }
    }
}

static void
SHORT_power(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1 = (float)*(short *)ip1;
        const float in2 = (float)*(short *)ip2;
        *((short *)op1) = (short) pow(in1, in2);
    }
}

static void
SHORT_fmod(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((short *)op1) = 0;
        }
        else {
            *((short *)op1)= in1 % in2;
        }

    }
}


#line 512

#define USHORT_floor_divide USHORT_divide
#define USHORT_fmax USHORT_maximum
#define USHORT_fmin USHORT_minimum

static void
USHORT_ones_like(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    OUTPUT_LOOP {
        *((ushort *)op1) = 1;
    }
}

static void
USHORT_square(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        *((ushort *)op1) = in1*in1;
    }
}

static void
USHORT_reciprocal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        *((ushort *)op1) = (ushort)(1.0/in1);
    }
}

static void
USHORT_conjugate(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        *((ushort *)op1) = in1;
    }
}

static void
USHORT_negative(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        *((ushort *)op1) = (ushort)(-(short)in1);
    }
}

static void
USHORT_logical_not(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        *((Bool *)op1) = !in1;
    }
}

static void
USHORT_invert(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        *((ushort *)op1) = ~in1;
    }
}

#line 585
static void
USHORT_add(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        *((ushort *)op1) = in1 + in2;
    }
}

#line 585
static void
USHORT_subtract(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        *((ushort *)op1) = in1 - in2;
    }
}

#line 585
static void
USHORT_multiply(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        *((ushort *)op1) = in1 * in2;
    }
}

#line 585
static void
USHORT_bitwise_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        *((ushort *)op1) = in1 & in2;
    }
}

#line 585
static void
USHORT_bitwise_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        *((ushort *)op1) = in1 | in2;
    }
}

#line 585
static void
USHORT_bitwise_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        *((ushort *)op1) = in1 ^ in2;
    }
}

#line 585
static void
USHORT_left_shift(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        *((ushort *)op1) = in1 << in2;
    }
}

#line 585
static void
USHORT_right_shift(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        *((ushort *)op1) = in1 >> in2;
    }
}


#line 601
static void
USHORT_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        *((Bool *)op1) = in1 == in2;
    }
}

#line 601
static void
USHORT_not_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        *((Bool *)op1) = in1 != in2;
    }
}

#line 601
static void
USHORT_greater(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        *((Bool *)op1) = in1 > in2;
    }
}

#line 601
static void
USHORT_greater_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        *((Bool *)op1) = in1 >= in2;
    }
}

#line 601
static void
USHORT_less(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        *((Bool *)op1) = in1 < in2;
    }
}

#line 601
static void
USHORT_less_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        *((Bool *)op1) = in1 <= in2;
    }
}

#line 601
static void
USHORT_logical_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        *((Bool *)op1) = in1 && in2;
    }
}

#line 601
static void
USHORT_logical_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        *((Bool *)op1) = in1 || in2;
    }
}


static void
USHORT_logical_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        *((Bool *)op1)= (in1 && !in2) || (!in1 && in2);
    }
}

#line 626
static void
USHORT_maximum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        *((ushort *)op1) = (in1 > in2) ? in1 : in2;
    }
}

#line 626
static void
USHORT_minimum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        *((ushort *)op1) = (in1 < in2) ? in1 : in2;
    }
}


static void
USHORT_true_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((float *)op1) = 0;
        }
        else {
            *((float *)op1) = (float)in1 / (float)in2;
        }
    }
}

static void
USHORT_power(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1 = (float)*(ushort *)ip1;
        const float in2 = (float)*(ushort *)ip2;
        *((ushort *)op1) = (ushort) pow(in1, in2);
    }
}

static void
USHORT_fmod(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((ushort *)op1) = 0;
        }
        else {
            *((ushort *)op1)= in1 % in2;
        }

    }
}



static void
USHORT_absolute(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        *((ushort *)op1) = in1;
    }
}

static void
SHORT_absolute(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const short in1 = *(short *)ip1;
        *((short *)op1) = (in1 >= 0) ? in1 : -in1;
    }
}

static void
USHORT_sign(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        *((ushort *)op1) = in1 > 0 ? 1 : 0;
    }
}

static void
SHORT_sign(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const short in1 = *(short *)ip1;
        *((short *)op1) = in1 > 0 ? 1 : (in1 < 0 ? -1 : 0);
    }
}

static void
SHORT_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((short *)op1) = 0;
        }
        else if (((in1 > 0) != (in2 > 0)) && (in1 % in2 != 0)) {
            *((short *)op1) = in1/in2 - 1;
        }
        else {
            *((short *)op1) = in1/in2;
        }
    }
}

static void
USHORT_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((ushort *)op1) = 0;
        }
        else {
            *((ushort *)op1)= in1/in2;
        }
    }
}

static void
SHORT_remainder(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const short in1 = *(short *)ip1;
        const short in2 = *(short *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((short *)op1) = 0;
        }
        else {
            /* handle mixed case the way Python does */
            const short rem = in1 % in2;
            if ((in1 > 0) == (in2 > 0) || rem == 0) {
                *((short *)op1) = rem;
            }
            else {
                *((short *)op1) = rem + in2;
            }
        }
    }
}

static void
USHORT_remainder(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ushort in1 = *(ushort *)ip1;
        const ushort in2 = *(ushort *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((short *)op1) = 0;
        }
        else {
            *((short *)op1) = in1 % in2;
        }
    }
}


#line 506

#line 512

#define INT_floor_divide INT_divide
#define INT_fmax INT_maximum
#define INT_fmin INT_minimum

static void
INT_ones_like(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    OUTPUT_LOOP {
        *((int *)op1) = 1;
    }
}

static void
INT_square(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const int in1 = *(int *)ip1;
        *((int *)op1) = in1*in1;
    }
}

static void
INT_reciprocal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const int in1 = *(int *)ip1;
        *((int *)op1) = (int)(1.0/in1);
    }
}

static void
INT_conjugate(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const int in1 = *(int *)ip1;
        *((int *)op1) = in1;
    }
}

static void
INT_negative(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const int in1 = *(int *)ip1;
        *((int *)op1) = (int)(-(int)in1);
    }
}

static void
INT_logical_not(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const int in1 = *(int *)ip1;
        *((Bool *)op1) = !in1;
    }
}

static void
INT_invert(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const int in1 = *(int *)ip1;
        *((int *)op1) = ~in1;
    }
}

#line 585
static void
INT_add(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        *((int *)op1) = in1 + in2;
    }
}

#line 585
static void
INT_subtract(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        *((int *)op1) = in1 - in2;
    }
}

#line 585
static void
INT_multiply(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        *((int *)op1) = in1 * in2;
    }
}

#line 585
static void
INT_bitwise_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        *((int *)op1) = in1 & in2;
    }
}

#line 585
static void
INT_bitwise_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        *((int *)op1) = in1 | in2;
    }
}

#line 585
static void
INT_bitwise_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        *((int *)op1) = in1 ^ in2;
    }
}

#line 585
static void
INT_left_shift(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        *((int *)op1) = in1 << in2;
    }
}

#line 585
static void
INT_right_shift(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        *((int *)op1) = in1 >> in2;
    }
}


#line 601
static void
INT_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        *((Bool *)op1) = in1 == in2;
    }
}

#line 601
static void
INT_not_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        *((Bool *)op1) = in1 != in2;
    }
}

#line 601
static void
INT_greater(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        *((Bool *)op1) = in1 > in2;
    }
}

#line 601
static void
INT_greater_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        *((Bool *)op1) = in1 >= in2;
    }
}

#line 601
static void
INT_less(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        *((Bool *)op1) = in1 < in2;
    }
}

#line 601
static void
INT_less_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        *((Bool *)op1) = in1 <= in2;
    }
}

#line 601
static void
INT_logical_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        *((Bool *)op1) = in1 && in2;
    }
}

#line 601
static void
INT_logical_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        *((Bool *)op1) = in1 || in2;
    }
}


static void
INT_logical_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        *((Bool *)op1)= (in1 && !in2) || (!in1 && in2);
    }
}

#line 626
static void
INT_maximum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        *((int *)op1) = (in1 > in2) ? in1 : in2;
    }
}

#line 626
static void
INT_minimum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        *((int *)op1) = (in1 < in2) ? in1 : in2;
    }
}


static void
INT_true_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((double *)op1) = 0;
        }
        else {
            *((double *)op1) = (double)in1 / (double)in2;
        }
    }
}

static void
INT_power(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1 = (double)*(int *)ip1;
        const double in2 = (double)*(int *)ip2;
        *((int *)op1) = (int) pow(in1, in2);
    }
}

static void
INT_fmod(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((int *)op1) = 0;
        }
        else {
            *((int *)op1)= in1 % in2;
        }

    }
}


#line 512

#define UINT_floor_divide UINT_divide
#define UINT_fmax UINT_maximum
#define UINT_fmin UINT_minimum

static void
UINT_ones_like(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    OUTPUT_LOOP {
        *((uint *)op1) = 1;
    }
}

static void
UINT_square(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const uint in1 = *(uint *)ip1;
        *((uint *)op1) = in1*in1;
    }
}

static void
UINT_reciprocal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const uint in1 = *(uint *)ip1;
        *((uint *)op1) = (uint)(1.0/in1);
    }
}

static void
UINT_conjugate(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const uint in1 = *(uint *)ip1;
        *((uint *)op1) = in1;
    }
}

static void
UINT_negative(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const uint in1 = *(uint *)ip1;
        *((uint *)op1) = (uint)(-(int)in1);
    }
}

static void
UINT_logical_not(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const uint in1 = *(uint *)ip1;
        *((Bool *)op1) = !in1;
    }
}

static void
UINT_invert(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const uint in1 = *(uint *)ip1;
        *((uint *)op1) = ~in1;
    }
}

#line 585
static void
UINT_add(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        *((uint *)op1) = in1 + in2;
    }
}

#line 585
static void
UINT_subtract(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        *((uint *)op1) = in1 - in2;
    }
}

#line 585
static void
UINT_multiply(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        *((uint *)op1) = in1 * in2;
    }
}

#line 585
static void
UINT_bitwise_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        *((uint *)op1) = in1 & in2;
    }
}

#line 585
static void
UINT_bitwise_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        *((uint *)op1) = in1 | in2;
    }
}

#line 585
static void
UINT_bitwise_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        *((uint *)op1) = in1 ^ in2;
    }
}

#line 585
static void
UINT_left_shift(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        *((uint *)op1) = in1 << in2;
    }
}

#line 585
static void
UINT_right_shift(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        *((uint *)op1) = in1 >> in2;
    }
}


#line 601
static void
UINT_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        *((Bool *)op1) = in1 == in2;
    }
}

#line 601
static void
UINT_not_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        *((Bool *)op1) = in1 != in2;
    }
}

#line 601
static void
UINT_greater(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        *((Bool *)op1) = in1 > in2;
    }
}

#line 601
static void
UINT_greater_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        *((Bool *)op1) = in1 >= in2;
    }
}

#line 601
static void
UINT_less(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        *((Bool *)op1) = in1 < in2;
    }
}

#line 601
static void
UINT_less_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        *((Bool *)op1) = in1 <= in2;
    }
}

#line 601
static void
UINT_logical_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        *((Bool *)op1) = in1 && in2;
    }
}

#line 601
static void
UINT_logical_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        *((Bool *)op1) = in1 || in2;
    }
}


static void
UINT_logical_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        *((Bool *)op1)= (in1 && !in2) || (!in1 && in2);
    }
}

#line 626
static void
UINT_maximum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        *((uint *)op1) = (in1 > in2) ? in1 : in2;
    }
}

#line 626
static void
UINT_minimum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        *((uint *)op1) = (in1 < in2) ? in1 : in2;
    }
}


static void
UINT_true_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((double *)op1) = 0;
        }
        else {
            *((double *)op1) = (double)in1 / (double)in2;
        }
    }
}

static void
UINT_power(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1 = (double)*(uint *)ip1;
        const double in2 = (double)*(uint *)ip2;
        *((uint *)op1) = (uint) pow(in1, in2);
    }
}

static void
UINT_fmod(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((uint *)op1) = 0;
        }
        else {
            *((uint *)op1)= in1 % in2;
        }

    }
}



static void
UINT_absolute(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const uint in1 = *(uint *)ip1;
        *((uint *)op1) = in1;
    }
}

static void
INT_absolute(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const int in1 = *(int *)ip1;
        *((int *)op1) = (in1 >= 0) ? in1 : -in1;
    }
}

static void
UINT_sign(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const uint in1 = *(uint *)ip1;
        *((uint *)op1) = in1 > 0 ? 1 : 0;
    }
}

static void
INT_sign(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const int in1 = *(int *)ip1;
        *((int *)op1) = in1 > 0 ? 1 : (in1 < 0 ? -1 : 0);
    }
}

static void
INT_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((int *)op1) = 0;
        }
        else if (((in1 > 0) != (in2 > 0)) && (in1 % in2 != 0)) {
            *((int *)op1) = in1/in2 - 1;
        }
        else {
            *((int *)op1) = in1/in2;
        }
    }
}

static void
UINT_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((uint *)op1) = 0;
        }
        else {
            *((uint *)op1)= in1/in2;
        }
    }
}

static void
INT_remainder(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const int in1 = *(int *)ip1;
        const int in2 = *(int *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((int *)op1) = 0;
        }
        else {
            /* handle mixed case the way Python does */
            const int rem = in1 % in2;
            if ((in1 > 0) == (in2 > 0) || rem == 0) {
                *((int *)op1) = rem;
            }
            else {
                *((int *)op1) = rem + in2;
            }
        }
    }
}

static void
UINT_remainder(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const uint in1 = *(uint *)ip1;
        const uint in2 = *(uint *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((int *)op1) = 0;
        }
        else {
            *((int *)op1) = in1 % in2;
        }
    }
}


#line 506

#line 512

#define LONG_floor_divide LONG_divide
#define LONG_fmax LONG_maximum
#define LONG_fmin LONG_minimum

static void
LONG_ones_like(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    OUTPUT_LOOP {
        *((long *)op1) = 1;
    }
}

static void
LONG_square(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const long in1 = *(long *)ip1;
        *((long *)op1) = in1*in1;
    }
}

static void
LONG_reciprocal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const long in1 = *(long *)ip1;
        *((long *)op1) = (long)(1.0/in1);
    }
}

static void
LONG_conjugate(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const long in1 = *(long *)ip1;
        *((long *)op1) = in1;
    }
}

static void
LONG_negative(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const long in1 = *(long *)ip1;
        *((long *)op1) = (long)(-(long)in1);
    }
}

static void
LONG_logical_not(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const long in1 = *(long *)ip1;
        *((Bool *)op1) = !in1;
    }
}

static void
LONG_invert(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const long in1 = *(long *)ip1;
        *((long *)op1) = ~in1;
    }
}

#line 585
static void
LONG_add(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        *((long *)op1) = in1 + in2;
    }
}

#line 585
static void
LONG_subtract(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        *((long *)op1) = in1 - in2;
    }
}

#line 585
static void
LONG_multiply(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        *((long *)op1) = in1 * in2;
    }
}

#line 585
static void
LONG_bitwise_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        *((long *)op1) = in1 & in2;
    }
}

#line 585
static void
LONG_bitwise_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        *((long *)op1) = in1 | in2;
    }
}

#line 585
static void
LONG_bitwise_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        *((long *)op1) = in1 ^ in2;
    }
}

#line 585
static void
LONG_left_shift(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        *((long *)op1) = in1 << in2;
    }
}

#line 585
static void
LONG_right_shift(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        *((long *)op1) = in1 >> in2;
    }
}


#line 601
static void
LONG_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        *((Bool *)op1) = in1 == in2;
    }
}

#line 601
static void
LONG_not_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        *((Bool *)op1) = in1 != in2;
    }
}

#line 601
static void
LONG_greater(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        *((Bool *)op1) = in1 > in2;
    }
}

#line 601
static void
LONG_greater_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        *((Bool *)op1) = in1 >= in2;
    }
}

#line 601
static void
LONG_less(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        *((Bool *)op1) = in1 < in2;
    }
}

#line 601
static void
LONG_less_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        *((Bool *)op1) = in1 <= in2;
    }
}

#line 601
static void
LONG_logical_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        *((Bool *)op1) = in1 && in2;
    }
}

#line 601
static void
LONG_logical_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        *((Bool *)op1) = in1 || in2;
    }
}


static void
LONG_logical_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        *((Bool *)op1)= (in1 && !in2) || (!in1 && in2);
    }
}

#line 626
static void
LONG_maximum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        *((long *)op1) = (in1 > in2) ? in1 : in2;
    }
}

#line 626
static void
LONG_minimum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        *((long *)op1) = (in1 < in2) ? in1 : in2;
    }
}


static void
LONG_true_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((double *)op1) = 0;
        }
        else {
            *((double *)op1) = (double)in1 / (double)in2;
        }
    }
}

static void
LONG_power(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1 = (double)*(long *)ip1;
        const double in2 = (double)*(long *)ip2;
        *((long *)op1) = (long) pow(in1, in2);
    }
}

static void
LONG_fmod(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((long *)op1) = 0;
        }
        else {
            *((long *)op1)= in1 % in2;
        }

    }
}


#line 512

#define ULONG_floor_divide ULONG_divide
#define ULONG_fmax ULONG_maximum
#define ULONG_fmin ULONG_minimum

static void
ULONG_ones_like(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    OUTPUT_LOOP {
        *((ulong *)op1) = 1;
    }
}

static void
ULONG_square(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        *((ulong *)op1) = in1*in1;
    }
}

static void
ULONG_reciprocal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        *((ulong *)op1) = (ulong)(1.0/in1);
    }
}

static void
ULONG_conjugate(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        *((ulong *)op1) = in1;
    }
}

static void
ULONG_negative(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        *((ulong *)op1) = (ulong)(-(long)in1);
    }
}

static void
ULONG_logical_not(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        *((Bool *)op1) = !in1;
    }
}

static void
ULONG_invert(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        *((ulong *)op1) = ~in1;
    }
}

#line 585
static void
ULONG_add(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        *((ulong *)op1) = in1 + in2;
    }
}

#line 585
static void
ULONG_subtract(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        *((ulong *)op1) = in1 - in2;
    }
}

#line 585
static void
ULONG_multiply(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        *((ulong *)op1) = in1 * in2;
    }
}

#line 585
static void
ULONG_bitwise_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        *((ulong *)op1) = in1 & in2;
    }
}

#line 585
static void
ULONG_bitwise_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        *((ulong *)op1) = in1 | in2;
    }
}

#line 585
static void
ULONG_bitwise_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        *((ulong *)op1) = in1 ^ in2;
    }
}

#line 585
static void
ULONG_left_shift(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        *((ulong *)op1) = in1 << in2;
    }
}

#line 585
static void
ULONG_right_shift(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        *((ulong *)op1) = in1 >> in2;
    }
}


#line 601
static void
ULONG_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        *((Bool *)op1) = in1 == in2;
    }
}

#line 601
static void
ULONG_not_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        *((Bool *)op1) = in1 != in2;
    }
}

#line 601
static void
ULONG_greater(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        *((Bool *)op1) = in1 > in2;
    }
}

#line 601
static void
ULONG_greater_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        *((Bool *)op1) = in1 >= in2;
    }
}

#line 601
static void
ULONG_less(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        *((Bool *)op1) = in1 < in2;
    }
}

#line 601
static void
ULONG_less_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        *((Bool *)op1) = in1 <= in2;
    }
}

#line 601
static void
ULONG_logical_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        *((Bool *)op1) = in1 && in2;
    }
}

#line 601
static void
ULONG_logical_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        *((Bool *)op1) = in1 || in2;
    }
}


static void
ULONG_logical_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        *((Bool *)op1)= (in1 && !in2) || (!in1 && in2);
    }
}

#line 626
static void
ULONG_maximum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        *((ulong *)op1) = (in1 > in2) ? in1 : in2;
    }
}

#line 626
static void
ULONG_minimum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        *((ulong *)op1) = (in1 < in2) ? in1 : in2;
    }
}


static void
ULONG_true_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((double *)op1) = 0;
        }
        else {
            *((double *)op1) = (double)in1 / (double)in2;
        }
    }
}

static void
ULONG_power(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1 = (double)*(ulong *)ip1;
        const double in2 = (double)*(ulong *)ip2;
        *((ulong *)op1) = (ulong) pow(in1, in2);
    }
}

static void
ULONG_fmod(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((ulong *)op1) = 0;
        }
        else {
            *((ulong *)op1)= in1 % in2;
        }

    }
}



static void
ULONG_absolute(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        *((ulong *)op1) = in1;
    }
}

static void
LONG_absolute(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const long in1 = *(long *)ip1;
        *((long *)op1) = (in1 >= 0) ? in1 : -in1;
    }
}

static void
ULONG_sign(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        *((ulong *)op1) = in1 > 0 ? 1 : 0;
    }
}

static void
LONG_sign(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const long in1 = *(long *)ip1;
        *((long *)op1) = in1 > 0 ? 1 : (in1 < 0 ? -1 : 0);
    }
}

static void
LONG_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((long *)op1) = 0;
        }
        else if (((in1 > 0) != (in2 > 0)) && (in1 % in2 != 0)) {
            *((long *)op1) = in1/in2 - 1;
        }
        else {
            *((long *)op1) = in1/in2;
        }
    }
}

static void
ULONG_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((ulong *)op1) = 0;
        }
        else {
            *((ulong *)op1)= in1/in2;
        }
    }
}

static void
LONG_remainder(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const long in1 = *(long *)ip1;
        const long in2 = *(long *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((long *)op1) = 0;
        }
        else {
            /* handle mixed case the way Python does */
            const long rem = in1 % in2;
            if ((in1 > 0) == (in2 > 0) || rem == 0) {
                *((long *)op1) = rem;
            }
            else {
                *((long *)op1) = rem + in2;
            }
        }
    }
}

static void
ULONG_remainder(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulong in1 = *(ulong *)ip1;
        const ulong in2 = *(ulong *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((long *)op1) = 0;
        }
        else {
            *((long *)op1) = in1 % in2;
        }
    }
}


#line 506

#line 512

#define LONGLONG_floor_divide LONGLONG_divide
#define LONGLONG_fmax LONGLONG_maximum
#define LONGLONG_fmin LONGLONG_minimum

static void
LONGLONG_ones_like(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    OUTPUT_LOOP {
        *((longlong *)op1) = 1;
    }
}

static void
LONGLONG_square(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        *((longlong *)op1) = in1*in1;
    }
}

static void
LONGLONG_reciprocal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        *((longlong *)op1) = (longlong)(1.0/in1);
    }
}

static void
LONGLONG_conjugate(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        *((longlong *)op1) = in1;
    }
}

static void
LONGLONG_negative(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        *((longlong *)op1) = (longlong)(-(longlong)in1);
    }
}

static void
LONGLONG_logical_not(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        *((Bool *)op1) = !in1;
    }
}

static void
LONGLONG_invert(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        *((longlong *)op1) = ~in1;
    }
}

#line 585
static void
LONGLONG_add(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        *((longlong *)op1) = in1 + in2;
    }
}

#line 585
static void
LONGLONG_subtract(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        *((longlong *)op1) = in1 - in2;
    }
}

#line 585
static void
LONGLONG_multiply(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        *((longlong *)op1) = in1 * in2;
    }
}

#line 585
static void
LONGLONG_bitwise_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        *((longlong *)op1) = in1 & in2;
    }
}

#line 585
static void
LONGLONG_bitwise_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        *((longlong *)op1) = in1 | in2;
    }
}

#line 585
static void
LONGLONG_bitwise_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        *((longlong *)op1) = in1 ^ in2;
    }
}

#line 585
static void
LONGLONG_left_shift(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        *((longlong *)op1) = in1 << in2;
    }
}

#line 585
static void
LONGLONG_right_shift(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        *((longlong *)op1) = in1 >> in2;
    }
}


#line 601
static void
LONGLONG_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        *((Bool *)op1) = in1 == in2;
    }
}

#line 601
static void
LONGLONG_not_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        *((Bool *)op1) = in1 != in2;
    }
}

#line 601
static void
LONGLONG_greater(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        *((Bool *)op1) = in1 > in2;
    }
}

#line 601
static void
LONGLONG_greater_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        *((Bool *)op1) = in1 >= in2;
    }
}

#line 601
static void
LONGLONG_less(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        *((Bool *)op1) = in1 < in2;
    }
}

#line 601
static void
LONGLONG_less_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        *((Bool *)op1) = in1 <= in2;
    }
}

#line 601
static void
LONGLONG_logical_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        *((Bool *)op1) = in1 && in2;
    }
}

#line 601
static void
LONGLONG_logical_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        *((Bool *)op1) = in1 || in2;
    }
}


static void
LONGLONG_logical_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        *((Bool *)op1)= (in1 && !in2) || (!in1 && in2);
    }
}

#line 626
static void
LONGLONG_maximum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        *((longlong *)op1) = (in1 > in2) ? in1 : in2;
    }
}

#line 626
static void
LONGLONG_minimum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        *((longlong *)op1) = (in1 < in2) ? in1 : in2;
    }
}


static void
LONGLONG_true_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((double *)op1) = 0;
        }
        else {
            *((double *)op1) = (double)in1 / (double)in2;
        }
    }
}

static void
LONGLONG_power(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1 = (double)*(longlong *)ip1;
        const double in2 = (double)*(longlong *)ip2;
        *((longlong *)op1) = (longlong) pow(in1, in2);
    }
}

static void
LONGLONG_fmod(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((longlong *)op1) = 0;
        }
        else {
            *((longlong *)op1)= in1 % in2;
        }

    }
}


#line 512

#define ULONGLONG_floor_divide ULONGLONG_divide
#define ULONGLONG_fmax ULONGLONG_maximum
#define ULONGLONG_fmin ULONGLONG_minimum

static void
ULONGLONG_ones_like(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    OUTPUT_LOOP {
        *((ulonglong *)op1) = 1;
    }
}

static void
ULONGLONG_square(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        *((ulonglong *)op1) = in1*in1;
    }
}

static void
ULONGLONG_reciprocal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        *((ulonglong *)op1) = (ulonglong)(1.0/in1);
    }
}

static void
ULONGLONG_conjugate(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        *((ulonglong *)op1) = in1;
    }
}

static void
ULONGLONG_negative(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        *((ulonglong *)op1) = (ulonglong)(-(longlong)in1);
    }
}

static void
ULONGLONG_logical_not(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        *((Bool *)op1) = !in1;
    }
}

static void
ULONGLONG_invert(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        *((ulonglong *)op1) = ~in1;
    }
}

#line 585
static void
ULONGLONG_add(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        *((ulonglong *)op1) = in1 + in2;
    }
}

#line 585
static void
ULONGLONG_subtract(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        *((ulonglong *)op1) = in1 - in2;
    }
}

#line 585
static void
ULONGLONG_multiply(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        *((ulonglong *)op1) = in1 * in2;
    }
}

#line 585
static void
ULONGLONG_bitwise_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        *((ulonglong *)op1) = in1 & in2;
    }
}

#line 585
static void
ULONGLONG_bitwise_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        *((ulonglong *)op1) = in1 | in2;
    }
}

#line 585
static void
ULONGLONG_bitwise_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        *((ulonglong *)op1) = in1 ^ in2;
    }
}

#line 585
static void
ULONGLONG_left_shift(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        *((ulonglong *)op1) = in1 << in2;
    }
}

#line 585
static void
ULONGLONG_right_shift(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        *((ulonglong *)op1) = in1 >> in2;
    }
}


#line 601
static void
ULONGLONG_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        *((Bool *)op1) = in1 == in2;
    }
}

#line 601
static void
ULONGLONG_not_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        *((Bool *)op1) = in1 != in2;
    }
}

#line 601
static void
ULONGLONG_greater(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        *((Bool *)op1) = in1 > in2;
    }
}

#line 601
static void
ULONGLONG_greater_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        *((Bool *)op1) = in1 >= in2;
    }
}

#line 601
static void
ULONGLONG_less(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        *((Bool *)op1) = in1 < in2;
    }
}

#line 601
static void
ULONGLONG_less_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        *((Bool *)op1) = in1 <= in2;
    }
}

#line 601
static void
ULONGLONG_logical_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        *((Bool *)op1) = in1 && in2;
    }
}

#line 601
static void
ULONGLONG_logical_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        *((Bool *)op1) = in1 || in2;
    }
}


static void
ULONGLONG_logical_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        *((Bool *)op1)= (in1 && !in2) || (!in1 && in2);
    }
}

#line 626
static void
ULONGLONG_maximum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        *((ulonglong *)op1) = (in1 > in2) ? in1 : in2;
    }
}

#line 626
static void
ULONGLONG_minimum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        *((ulonglong *)op1) = (in1 < in2) ? in1 : in2;
    }
}


static void
ULONGLONG_true_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((double *)op1) = 0;
        }
        else {
            *((double *)op1) = (double)in1 / (double)in2;
        }
    }
}

static void
ULONGLONG_power(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1 = (double)*(ulonglong *)ip1;
        const double in2 = (double)*(ulonglong *)ip2;
        *((ulonglong *)op1) = (ulonglong) pow(in1, in2);
    }
}

static void
ULONGLONG_fmod(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((ulonglong *)op1) = 0;
        }
        else {
            *((ulonglong *)op1)= in1 % in2;
        }

    }
}



static void
ULONGLONG_absolute(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        *((ulonglong *)op1) = in1;
    }
}

static void
LONGLONG_absolute(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        *((longlong *)op1) = (in1 >= 0) ? in1 : -in1;
    }
}

static void
ULONGLONG_sign(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        *((ulonglong *)op1) = in1 > 0 ? 1 : 0;
    }
}

static void
LONGLONG_sign(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        *((longlong *)op1) = in1 > 0 ? 1 : (in1 < 0 ? -1 : 0);
    }
}

static void
LONGLONG_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((longlong *)op1) = 0;
        }
        else if (((in1 > 0) != (in2 > 0)) && (in1 % in2 != 0)) {
            *((longlong *)op1) = in1/in2 - 1;
        }
        else {
            *((longlong *)op1) = in1/in2;
        }
    }
}

static void
ULONGLONG_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((ulonglong *)op1) = 0;
        }
        else {
            *((ulonglong *)op1)= in1/in2;
        }
    }
}

static void
LONGLONG_remainder(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longlong in1 = *(longlong *)ip1;
        const longlong in2 = *(longlong *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((longlong *)op1) = 0;
        }
        else {
            /* handle mixed case the way Python does */
            const longlong rem = in1 % in2;
            if ((in1 > 0) == (in2 > 0) || rem == 0) {
                *((longlong *)op1) = rem;
            }
            else {
                *((longlong *)op1) = rem + in2;
            }
        }
    }
}

static void
ULONGLONG_remainder(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const ulonglong in1 = *(ulonglong *)ip1;
        const ulonglong in2 = *(ulonglong *)ip2;
        if (in2 == 0) {
            generate_divbyzero_error();
            *((longlong *)op1) = 0;
        }
        else {
            *((longlong *)op1) = in1 % in2;
        }
    }
}



/*
 *****************************************************************************
 **                             FLOAT LOOPS                                 **
 *****************************************************************************
 */


#line 808


#line 815
static void
FLOAT_add(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1 = *(float *)ip1;
        const float in2 = *(float *)ip2;
        *((float *)op1) = in1 + in2;
    }
}

#line 815
static void
FLOAT_subtract(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1 = *(float *)ip1;
        const float in2 = *(float *)ip2;
        *((float *)op1) = in1 - in2;
    }
}

#line 815
static void
FLOAT_multiply(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1 = *(float *)ip1;
        const float in2 = *(float *)ip2;
        *((float *)op1) = in1 * in2;
    }
}

#line 815
static void
FLOAT_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1 = *(float *)ip1;
        const float in2 = *(float *)ip2;
        *((float *)op1) = in1 / in2;
    }
}


#line 831
static void
FLOAT_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1 = *(float *)ip1;
        const float in2 = *(float *)ip2;
        *((Bool *)op1) = in1 == in2;
    }
}

#line 831
static void
FLOAT_not_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1 = *(float *)ip1;
        const float in2 = *(float *)ip2;
        *((Bool *)op1) = in1 != in2;
    }
}

#line 831
static void
FLOAT_less(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1 = *(float *)ip1;
        const float in2 = *(float *)ip2;
        *((Bool *)op1) = in1 < in2;
    }
}

#line 831
static void
FLOAT_less_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1 = *(float *)ip1;
        const float in2 = *(float *)ip2;
        *((Bool *)op1) = in1 <= in2;
    }
}

#line 831
static void
FLOAT_greater(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1 = *(float *)ip1;
        const float in2 = *(float *)ip2;
        *((Bool *)op1) = in1 > in2;
    }
}

#line 831
static void
FLOAT_greater_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1 = *(float *)ip1;
        const float in2 = *(float *)ip2;
        *((Bool *)op1) = in1 >= in2;
    }
}

#line 831
static void
FLOAT_logical_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1 = *(float *)ip1;
        const float in2 = *(float *)ip2;
        *((Bool *)op1) = in1 && in2;
    }
}

#line 831
static void
FLOAT_logical_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1 = *(float *)ip1;
        const float in2 = *(float *)ip2;
        *((Bool *)op1) = in1 || in2;
    }
}


static void
FLOAT_logical_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1 = *(float *)ip1;
        const float in2 = *(float *)ip2;
        *((Bool *)op1)= (in1 && !in2) || (!in1 && in2);
    }
}

static void
FLOAT_logical_not(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const float in1 = *(float *)ip1;
        *((Bool *)op1) = !in1;
    }
}

#line 865
static void
FLOAT_isnan(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const float in1 = *(float *)ip1;
        *((Bool *)op1) = npy_isnan(in1) != 0;
    }
}

#line 865
static void
FLOAT_isinf(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const float in1 = *(float *)ip1;
        *((Bool *)op1) = npy_isinf(in1) != 0;
    }
}

#line 865
static void
FLOAT_isfinite(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const float in1 = *(float *)ip1;
        *((Bool *)op1) = npy_isfinite(in1) != 0;
    }
}

#line 865
static void
FLOAT_signbit(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const float in1 = *(float *)ip1;
        *((Bool *)op1) = npy_signbit(in1) != 0;
    }
}


#line 879
static void
FLOAT_maximum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    /*  */
    BINARY_LOOP {
        const float in1 = *(float *)ip1;
        const float in2 = *(float *)ip2;
        *((float *)op1) = (in1 >= in2 || npy_isnan(in1)) ? in1 : in2;
    }
}

#line 879
static void
FLOAT_minimum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    /*  */
    BINARY_LOOP {
        const float in1 = *(float *)ip1;
        const float in2 = *(float *)ip2;
        *((float *)op1) = (in1 <= in2 || npy_isnan(in1)) ? in1 : in2;
    }
}


#line 895
static void
FLOAT_fmax(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    /*  */
    BINARY_LOOP {
        const float in1 = *(float *)ip1;
        const float in2 = *(float *)ip2;
        *((float *)op1) = (in1 >= in2 || npy_isnan(in2)) ? in1 : in2;
    }
}

#line 895
static void
FLOAT_fmin(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    /*  */
    BINARY_LOOP {
        const float in1 = *(float *)ip1;
        const float in2 = *(float *)ip2;
        *((float *)op1) = (in1 <= in2 || npy_isnan(in2)) ? in1 : in2;
    }
}


static void
FLOAT_floor_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1 = *(float *)ip1;
        const float in2 = *(float *)ip2;
        *((float *)op1) = npy_floorf(in1/in2);
    }
}

static void
FLOAT_remainder(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1 = *(float *)ip1;
        const float in2 = *(float *)ip2;
        const float res = npy_fmodf(in1,in2);
        if (res && ((in2 < 0) != (res < 0))) {
            *((float *)op1) = res + in2;
        }
        else {
            *((float *)op1) = res;
        }
    }
}

static void
FLOAT_square(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const float in1 = *(float *)ip1;
        *((float *)op1) = in1*in1;
    }
}

static void
FLOAT_reciprocal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const float in1 = *(float *)ip1;
        *((float *)op1) = 1/in1;
    }
}

static void
FLOAT_ones_like(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    OUTPUT_LOOP {
        *((float *)op1) = 1;
    }
}

static void
FLOAT_conjugate(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const float in1 = *(float *)ip1;
        *((float *)op1) = in1;
    }
}

static void
FLOAT_absolute(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const float in1 = *(float *)ip1;
        const float tmp = in1 > 0 ? in1 : -in1;
        /* add 0 to clear -0.0 */
        *((float *)op1) = tmp + 0;
    }
}

static void
FLOAT_negative(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const float in1 = *(float *)ip1;
        *((float *)op1) = -in1;
    }
}

static void
FLOAT_sign(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    /* Sign of nan is nan */
    UNARY_LOOP {
        const float in1 = *(float *)ip1;
        *((float *)op1) = in1 > 0 ? 1 : (in1 < 0 ? -1 : (in1 == 0 ? 0 : in1));
    }
}

static void
FLOAT_modf(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP_TWO_OUT {
        const float in1 = *(float *)ip1;
        *((float *)op1) = npy_modff(in1, (float *)op2);
    }
}

#ifdef HAVE_FREXPF
static void
FLOAT_frexp(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP_TWO_OUT {
        const float in1 = *(float *)ip1;
        *((float *)op1) = frexpf(in1, (int *)op2);
    }
}
#endif

#ifdef HAVE_LDEXPF
static void
FLOAT_ldexp(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1 = *(float *)ip1;
        const int in2 = *(int *)ip2;
        *((float *)op1) = ldexpf(in1, in2);
    }
}
#endif

#define FLOAT_true_divide FLOAT_divide


#line 808


#line 815
static void
DOUBLE_add(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1 = *(double *)ip1;
        const double in2 = *(double *)ip2;
        *((double *)op1) = in1 + in2;
    }
}

#line 815
static void
DOUBLE_subtract(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1 = *(double *)ip1;
        const double in2 = *(double *)ip2;
        *((double *)op1) = in1 - in2;
    }
}

#line 815
static void
DOUBLE_multiply(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1 = *(double *)ip1;
        const double in2 = *(double *)ip2;
        *((double *)op1) = in1 * in2;
    }
}

#line 815
static void
DOUBLE_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1 = *(double *)ip1;
        const double in2 = *(double *)ip2;
        *((double *)op1) = in1 / in2;
    }
}


#line 831
static void
DOUBLE_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1 = *(double *)ip1;
        const double in2 = *(double *)ip2;
        *((Bool *)op1) = in1 == in2;
    }
}

#line 831
static void
DOUBLE_not_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1 = *(double *)ip1;
        const double in2 = *(double *)ip2;
        *((Bool *)op1) = in1 != in2;
    }
}

#line 831
static void
DOUBLE_less(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1 = *(double *)ip1;
        const double in2 = *(double *)ip2;
        *((Bool *)op1) = in1 < in2;
    }
}

#line 831
static void
DOUBLE_less_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1 = *(double *)ip1;
        const double in2 = *(double *)ip2;
        *((Bool *)op1) = in1 <= in2;
    }
}

#line 831
static void
DOUBLE_greater(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1 = *(double *)ip1;
        const double in2 = *(double *)ip2;
        *((Bool *)op1) = in1 > in2;
    }
}

#line 831
static void
DOUBLE_greater_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1 = *(double *)ip1;
        const double in2 = *(double *)ip2;
        *((Bool *)op1) = in1 >= in2;
    }
}

#line 831
static void
DOUBLE_logical_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1 = *(double *)ip1;
        const double in2 = *(double *)ip2;
        *((Bool *)op1) = in1 && in2;
    }
}

#line 831
static void
DOUBLE_logical_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1 = *(double *)ip1;
        const double in2 = *(double *)ip2;
        *((Bool *)op1) = in1 || in2;
    }
}


static void
DOUBLE_logical_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1 = *(double *)ip1;
        const double in2 = *(double *)ip2;
        *((Bool *)op1)= (in1 && !in2) || (!in1 && in2);
    }
}

static void
DOUBLE_logical_not(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const double in1 = *(double *)ip1;
        *((Bool *)op1) = !in1;
    }
}

#line 865
static void
DOUBLE_isnan(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const double in1 = *(double *)ip1;
        *((Bool *)op1) = npy_isnan(in1) != 0;
    }
}

#line 865
static void
DOUBLE_isinf(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const double in1 = *(double *)ip1;
        *((Bool *)op1) = npy_isinf(in1) != 0;
    }
}

#line 865
static void
DOUBLE_isfinite(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const double in1 = *(double *)ip1;
        *((Bool *)op1) = npy_isfinite(in1) != 0;
    }
}

#line 865
static void
DOUBLE_signbit(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const double in1 = *(double *)ip1;
        *((Bool *)op1) = npy_signbit(in1) != 0;
    }
}


#line 879
static void
DOUBLE_maximum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    /*  */
    BINARY_LOOP {
        const double in1 = *(double *)ip1;
        const double in2 = *(double *)ip2;
        *((double *)op1) = (in1 >= in2 || npy_isnan(in1)) ? in1 : in2;
    }
}

#line 879
static void
DOUBLE_minimum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    /*  */
    BINARY_LOOP {
        const double in1 = *(double *)ip1;
        const double in2 = *(double *)ip2;
        *((double *)op1) = (in1 <= in2 || npy_isnan(in1)) ? in1 : in2;
    }
}


#line 895
static void
DOUBLE_fmax(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    /*  */
    BINARY_LOOP {
        const double in1 = *(double *)ip1;
        const double in2 = *(double *)ip2;
        *((double *)op1) = (in1 >= in2 || npy_isnan(in2)) ? in1 : in2;
    }
}

#line 895
static void
DOUBLE_fmin(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    /*  */
    BINARY_LOOP {
        const double in1 = *(double *)ip1;
        const double in2 = *(double *)ip2;
        *((double *)op1) = (in1 <= in2 || npy_isnan(in2)) ? in1 : in2;
    }
}


static void
DOUBLE_floor_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1 = *(double *)ip1;
        const double in2 = *(double *)ip2;
        *((double *)op1) = npy_floor(in1/in2);
    }
}

static void
DOUBLE_remainder(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1 = *(double *)ip1;
        const double in2 = *(double *)ip2;
        const double res = npy_fmod(in1,in2);
        if (res && ((in2 < 0) != (res < 0))) {
            *((double *)op1) = res + in2;
        }
        else {
            *((double *)op1) = res;
        }
    }
}

static void
DOUBLE_square(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const double in1 = *(double *)ip1;
        *((double *)op1) = in1*in1;
    }
}

static void
DOUBLE_reciprocal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const double in1 = *(double *)ip1;
        *((double *)op1) = 1/in1;
    }
}

static void
DOUBLE_ones_like(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    OUTPUT_LOOP {
        *((double *)op1) = 1;
    }
}

static void
DOUBLE_conjugate(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const double in1 = *(double *)ip1;
        *((double *)op1) = in1;
    }
}

static void
DOUBLE_absolute(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const double in1 = *(double *)ip1;
        const double tmp = in1 > 0 ? in1 : -in1;
        /* add 0 to clear -0.0 */
        *((double *)op1) = tmp + 0;
    }
}

static void
DOUBLE_negative(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const double in1 = *(double *)ip1;
        *((double *)op1) = -in1;
    }
}

static void
DOUBLE_sign(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    /* Sign of nan is nan */
    UNARY_LOOP {
        const double in1 = *(double *)ip1;
        *((double *)op1) = in1 > 0 ? 1 : (in1 < 0 ? -1 : (in1 == 0 ? 0 : in1));
    }
}

static void
DOUBLE_modf(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP_TWO_OUT {
        const double in1 = *(double *)ip1;
        *((double *)op1) = npy_modf(in1, (double *)op2);
    }
}

#ifdef HAVE_FREXP
static void
DOUBLE_frexp(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP_TWO_OUT {
        const double in1 = *(double *)ip1;
        *((double *)op1) = frexp(in1, (int *)op2);
    }
}
#endif

#ifdef HAVE_LDEXP
static void
DOUBLE_ldexp(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1 = *(double *)ip1;
        const int in2 = *(int *)ip2;
        *((double *)op1) = ldexp(in1, in2);
    }
}
#endif

#define DOUBLE_true_divide DOUBLE_divide


#line 808


#line 815
static void
LONGDOUBLE_add(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        const longdouble in2 = *(longdouble *)ip2;
        *((longdouble *)op1) = in1 + in2;
    }
}

#line 815
static void
LONGDOUBLE_subtract(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        const longdouble in2 = *(longdouble *)ip2;
        *((longdouble *)op1) = in1 - in2;
    }
}

#line 815
static void
LONGDOUBLE_multiply(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        const longdouble in2 = *(longdouble *)ip2;
        *((longdouble *)op1) = in1 * in2;
    }
}

#line 815
static void
LONGDOUBLE_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        const longdouble in2 = *(longdouble *)ip2;
        *((longdouble *)op1) = in1 / in2;
    }
}


#line 831
static void
LONGDOUBLE_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        const longdouble in2 = *(longdouble *)ip2;
        *((Bool *)op1) = in1 == in2;
    }
}

#line 831
static void
LONGDOUBLE_not_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        const longdouble in2 = *(longdouble *)ip2;
        *((Bool *)op1) = in1 != in2;
    }
}

#line 831
static void
LONGDOUBLE_less(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        const longdouble in2 = *(longdouble *)ip2;
        *((Bool *)op1) = in1 < in2;
    }
}

#line 831
static void
LONGDOUBLE_less_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        const longdouble in2 = *(longdouble *)ip2;
        *((Bool *)op1) = in1 <= in2;
    }
}

#line 831
static void
LONGDOUBLE_greater(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        const longdouble in2 = *(longdouble *)ip2;
        *((Bool *)op1) = in1 > in2;
    }
}

#line 831
static void
LONGDOUBLE_greater_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        const longdouble in2 = *(longdouble *)ip2;
        *((Bool *)op1) = in1 >= in2;
    }
}

#line 831
static void
LONGDOUBLE_logical_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        const longdouble in2 = *(longdouble *)ip2;
        *((Bool *)op1) = in1 && in2;
    }
}

#line 831
static void
LONGDOUBLE_logical_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        const longdouble in2 = *(longdouble *)ip2;
        *((Bool *)op1) = in1 || in2;
    }
}


static void
LONGDOUBLE_logical_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        const longdouble in2 = *(longdouble *)ip2;
        *((Bool *)op1)= (in1 && !in2) || (!in1 && in2);
    }
}

static void
LONGDOUBLE_logical_not(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        *((Bool *)op1) = !in1;
    }
}

#line 865
static void
LONGDOUBLE_isnan(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        *((Bool *)op1) = npy_isnan(in1) != 0;
    }
}

#line 865
static void
LONGDOUBLE_isinf(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        *((Bool *)op1) = npy_isinf(in1) != 0;
    }
}

#line 865
static void
LONGDOUBLE_isfinite(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        *((Bool *)op1) = npy_isfinite(in1) != 0;
    }
}

#line 865
static void
LONGDOUBLE_signbit(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        *((Bool *)op1) = npy_signbit(in1) != 0;
    }
}


#line 879
static void
LONGDOUBLE_maximum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    /*  */
    BINARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        const longdouble in2 = *(longdouble *)ip2;
        *((longdouble *)op1) = (in1 >= in2 || npy_isnan(in1)) ? in1 : in2;
    }
}

#line 879
static void
LONGDOUBLE_minimum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    /*  */
    BINARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        const longdouble in2 = *(longdouble *)ip2;
        *((longdouble *)op1) = (in1 <= in2 || npy_isnan(in1)) ? in1 : in2;
    }
}


#line 895
static void
LONGDOUBLE_fmax(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    /*  */
    BINARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        const longdouble in2 = *(longdouble *)ip2;
        *((longdouble *)op1) = (in1 >= in2 || npy_isnan(in2)) ? in1 : in2;
    }
}

#line 895
static void
LONGDOUBLE_fmin(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    /*  */
    BINARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        const longdouble in2 = *(longdouble *)ip2;
        *((longdouble *)op1) = (in1 <= in2 || npy_isnan(in2)) ? in1 : in2;
    }
}


static void
LONGDOUBLE_floor_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        const longdouble in2 = *(longdouble *)ip2;
        *((longdouble *)op1) = npy_floorl(in1/in2);
    }
}

static void
LONGDOUBLE_remainder(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        const longdouble in2 = *(longdouble *)ip2;
        const longdouble res = npy_fmodl(in1,in2);
        if (res && ((in2 < 0) != (res < 0))) {
            *((longdouble *)op1) = res + in2;
        }
        else {
            *((longdouble *)op1) = res;
        }
    }
}

static void
LONGDOUBLE_square(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        *((longdouble *)op1) = in1*in1;
    }
}

static void
LONGDOUBLE_reciprocal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        *((longdouble *)op1) = 1/in1;
    }
}

static void
LONGDOUBLE_ones_like(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    OUTPUT_LOOP {
        *((longdouble *)op1) = 1;
    }
}

static void
LONGDOUBLE_conjugate(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        *((longdouble *)op1) = in1;
    }
}

static void
LONGDOUBLE_absolute(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        const longdouble tmp = in1 > 0 ? in1 : -in1;
        /* add 0 to clear -0.0 */
        *((longdouble *)op1) = tmp + 0;
    }
}

static void
LONGDOUBLE_negative(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        *((longdouble *)op1) = -in1;
    }
}

static void
LONGDOUBLE_sign(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    /* Sign of nan is nan */
    UNARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        *((longdouble *)op1) = in1 > 0 ? 1 : (in1 < 0 ? -1 : (in1 == 0 ? 0 : in1));
    }
}

static void
LONGDOUBLE_modf(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP_TWO_OUT {
        const longdouble in1 = *(longdouble *)ip1;
        *((longdouble *)op1) = npy_modfl(in1, (longdouble *)op2);
    }
}

#ifdef HAVE_FREXPL
static void
LONGDOUBLE_frexp(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP_TWO_OUT {
        const longdouble in1 = *(longdouble *)ip1;
        *((longdouble *)op1) = frexpl(in1, (int *)op2);
    }
}
#endif

#ifdef HAVE_LDEXPL
static void
LONGDOUBLE_ldexp(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1 = *(longdouble *)ip1;
        const int in2 = *(int *)ip2;
        *((longdouble *)op1) = ldexpl(in1, in2);
    }
}
#endif

#define LONGDOUBLE_true_divide LONGDOUBLE_divide




/*
 *****************************************************************************
 **                           COMPLEX LOOPS                                 **
 *****************************************************************************
 */

#define CGE(xr,xi,yr,yi) (xr > yr || (xr == yr && xi >= yi))
#define CLE(xr,xi,yr,yi) (xr < yr || (xr == yr && xi <= yi))
#define CGT(xr,xi,yr,yi) (xr > yr || (xr == yr && xi > yi))
#define CLT(xr,xi,yr,yi) (xr < yr || (xr == yr && xi < yi))
#define CEQ(xr,xi,yr,yi) (xr == yr && xi == yi)
#define CNE(xr,xi,yr,yi) (xr != yr || xi != yi)

#line 1055

#line 1061
static void
CFLOAT_add(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        const float in2r = ((float *)ip2)[0];
        const float in2i = ((float *)ip2)[1];
        ((float *)op1)[0] = in1r + in2r;
        ((float *)op1)[1] = in1i + in2i;
    }
}

#line 1061
static void
CFLOAT_subtract(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        const float in2r = ((float *)ip2)[0];
        const float in2i = ((float *)ip2)[1];
        ((float *)op1)[0] = in1r - in2r;
        ((float *)op1)[1] = in1i - in2i;
    }
}


static void
CFLOAT_multiply(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        const float in2r = ((float *)ip2)[0];
        const float in2i = ((float *)ip2)[1];
        ((float *)op1)[0] = in1r*in2r - in1i*in2i;
        ((float *)op1)[1] = in1r*in2i + in1i*in2r;
    }
}

static void
CFLOAT_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        const float in2r = ((float *)ip2)[0];
        const float in2i = ((float *)ip2)[1];
        float d = in2r*in2r + in2i*in2i;
        ((float *)op1)[0] = (in1r*in2r + in1i*in2i)/d;
        ((float *)op1)[1] = (in1i*in2r - in1r*in2i)/d;
    }
}

static void
CFLOAT_floor_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        const float in2r = ((float *)ip2)[0];
        const float in2i = ((float *)ip2)[1];
        float d = in2r*in2r + in2i*in2i;
        ((float *)op1)[0] = npy_floorf((in1r*in2r + in1i*in2i)/d);
        ((float *)op1)[1] = 0;
    }
}

#line 1120
static void
CFLOAT_greater(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        const float in2r = ((float *)ip2)[0];
        const float in2i = ((float *)ip2)[1];
        *((Bool *)op1) = CGT(in1r,in1i,in2r,in2i);
    }
}

#line 1120
static void
CFLOAT_greater_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        const float in2r = ((float *)ip2)[0];
        const float in2i = ((float *)ip2)[1];
        *((Bool *)op1) = CGE(in1r,in1i,in2r,in2i);
    }
}

#line 1120
static void
CFLOAT_less(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        const float in2r = ((float *)ip2)[0];
        const float in2i = ((float *)ip2)[1];
        *((Bool *)op1) = CLT(in1r,in1i,in2r,in2i);
    }
}

#line 1120
static void
CFLOAT_less_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        const float in2r = ((float *)ip2)[0];
        const float in2i = ((float *)ip2)[1];
        *((Bool *)op1) = CLE(in1r,in1i,in2r,in2i);
    }
}

#line 1120
static void
CFLOAT_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        const float in2r = ((float *)ip2)[0];
        const float in2i = ((float *)ip2)[1];
        *((Bool *)op1) = CEQ(in1r,in1i,in2r,in2i);
    }
}

#line 1120
static void
CFLOAT_not_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        const float in2r = ((float *)ip2)[0];
        const float in2i = ((float *)ip2)[1];
        *((Bool *)op1) = CNE(in1r,in1i,in2r,in2i);
    }
}


#line 1138
static void
CFLOAT_logical_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        const float in2r = ((float *)ip2)[0];
        const float in2i = ((float *)ip2)[1];
        *((Bool *)op1) = (in1r || in1i) && (in2r || in2i);
    }
}

#line 1138
static void
CFLOAT_logical_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        const float in2r = ((float *)ip2)[0];
        const float in2i = ((float *)ip2)[1];
        *((Bool *)op1) = (in1r || in1i) || (in2r || in2i);
    }
}


static void
CFLOAT_logical_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        const float in2r = ((float *)ip2)[0];
        const float in2i = ((float *)ip2)[1];
        const Bool tmp1 = (in1r || in1i);
        const Bool tmp2 = (in2r || in2i);
        *((Bool *)op1) = (tmp1 && !tmp2) || (!tmp1 && tmp2);
    }
}

static void
CFLOAT_logical_not(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        *((Bool *)op1) = !(in1r || in1i);
    }
}

#line 1180
static void
CFLOAT_isnan(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        *((Bool *)op1) = npy_isnan(in1r) || npy_isnan(in1i);
    }
}

#line 1180
static void
CFLOAT_isinf(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        *((Bool *)op1) = npy_isinf(in1r) || npy_isinf(in1i);
    }
}

#line 1180
static void
CFLOAT_isfinite(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        *((Bool *)op1) = npy_isfinite(in1r) && npy_isfinite(in1i);
    }
}


static void
CFLOAT_square(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        ((float *)op1)[0] = in1r*in1r - in1i*in1i;
        ((float *)op1)[1] = in1r*in1i + in1i*in1r;
    }
}

static void
CFLOAT_reciprocal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        if (npy_fabsf(in1i) <= npy_fabsf(in1r)) {
            const float r = in1i/in1r;
            const float d = in1r + in1i*r;
            ((float *)op1)[0] = 1/d;
            ((float *)op1)[1] = -r/d;
        } else {
            const float r = in1r/in1i;
            const float d = in1r*r + in1i;
            ((float *)op1)[0] = r/d;
            ((float *)op1)[1] = -1/d;
        }
    }
}

static void
CFLOAT_ones_like(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    OUTPUT_LOOP {
        ((float *)op1)[0] = 1;
        ((float *)op1)[1] = 0;
    }
}

static void
CFLOAT_conjugate(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func)) {
    UNARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        ((float *)op1)[0] = in1r;
        ((float *)op1)[1] = -in1i;
    }
}

static void
CFLOAT_absolute(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        *((float *)op1) = npy_sqrtf(in1r*in1r + in1i*in1i);
    }
}

static void
CFLOAT_sign(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    /* fixme: sign of nan is currently 0 */
    UNARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        ((float *)op1)[0] = CGT(in1r, in1i, 0, 0) ?  1 :
                            (CLT(in1r, in1i, 0, 0) ? -1 :
                            (CEQ(in1r, in1i, 0, 0) ?  0 : NPY_NANF));
        ((float *)op1)[1] = 0;
    }
}

#line 1269
static void
CFLOAT_maximum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        const float in2r = ((float *)ip2)[0];
        const float in2i = ((float *)ip2)[1];
        if (CGE(in1r, in1i, in2r, in2i) || npy_isnan(in1r) || npy_isnan(in1i)) {
            ((float *)op1)[0] = in1r;
            ((float *)op1)[1] = in1i;
        }
        else {
            ((float *)op1)[0] = in2r;
            ((float *)op1)[1] = in2i;
        }
    }
}

#line 1269
static void
CFLOAT_minimum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        const float in2r = ((float *)ip2)[0];
        const float in2i = ((float *)ip2)[1];
        if (CLE(in1r, in1i, in2r, in2i) || npy_isnan(in1r) || npy_isnan(in1i)) {
            ((float *)op1)[0] = in1r;
            ((float *)op1)[1] = in1i;
        }
        else {
            ((float *)op1)[0] = in2r;
            ((float *)op1)[1] = in2i;
        }
    }
}


#line 1293
static void
CFLOAT_fmax(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        const float in2r = ((float *)ip2)[0];
        const float in2i = ((float *)ip2)[1];
        if (CGE(in1r, in1i, in2r, in2i) || npy_isnan(in2r) || npy_isnan(in2i)) {
            ((float *)op1)[0] = in1r;
            ((float *)op1)[1] = in1i;
        }
        else {
            ((float *)op1)[0] = in2r;
            ((float *)op1)[1] = in2i;
        }
    }
}

#line 1293
static void
CFLOAT_fmin(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const float in1r = ((float *)ip1)[0];
        const float in1i = ((float *)ip1)[1];
        const float in2r = ((float *)ip2)[0];
        const float in2i = ((float *)ip2)[1];
        if (CLE(in1r, in1i, in2r, in2i) || npy_isnan(in2r) || npy_isnan(in2i)) {
            ((float *)op1)[0] = in1r;
            ((float *)op1)[1] = in1i;
        }
        else {
            ((float *)op1)[0] = in2r;
            ((float *)op1)[1] = in2i;
        }
    }
}


#define CFLOAT_true_divide CFLOAT_divide


#line 1055

#line 1061
static void
CDOUBLE_add(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        const double in2r = ((double *)ip2)[0];
        const double in2i = ((double *)ip2)[1];
        ((double *)op1)[0] = in1r + in2r;
        ((double *)op1)[1] = in1i + in2i;
    }
}

#line 1061
static void
CDOUBLE_subtract(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        const double in2r = ((double *)ip2)[0];
        const double in2i = ((double *)ip2)[1];
        ((double *)op1)[0] = in1r - in2r;
        ((double *)op1)[1] = in1i - in2i;
    }
}


static void
CDOUBLE_multiply(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        const double in2r = ((double *)ip2)[0];
        const double in2i = ((double *)ip2)[1];
        ((double *)op1)[0] = in1r*in2r - in1i*in2i;
        ((double *)op1)[1] = in1r*in2i + in1i*in2r;
    }
}

static void
CDOUBLE_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        const double in2r = ((double *)ip2)[0];
        const double in2i = ((double *)ip2)[1];
        double d = in2r*in2r + in2i*in2i;
        ((double *)op1)[0] = (in1r*in2r + in1i*in2i)/d;
        ((double *)op1)[1] = (in1i*in2r - in1r*in2i)/d;
    }
}

static void
CDOUBLE_floor_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        const double in2r = ((double *)ip2)[0];
        const double in2i = ((double *)ip2)[1];
        double d = in2r*in2r + in2i*in2i;
        ((double *)op1)[0] = npy_floor((in1r*in2r + in1i*in2i)/d);
        ((double *)op1)[1] = 0;
    }
}

#line 1120
static void
CDOUBLE_greater(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        const double in2r = ((double *)ip2)[0];
        const double in2i = ((double *)ip2)[1];
        *((Bool *)op1) = CGT(in1r,in1i,in2r,in2i);
    }
}

#line 1120
static void
CDOUBLE_greater_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        const double in2r = ((double *)ip2)[0];
        const double in2i = ((double *)ip2)[1];
        *((Bool *)op1) = CGE(in1r,in1i,in2r,in2i);
    }
}

#line 1120
static void
CDOUBLE_less(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        const double in2r = ((double *)ip2)[0];
        const double in2i = ((double *)ip2)[1];
        *((Bool *)op1) = CLT(in1r,in1i,in2r,in2i);
    }
}

#line 1120
static void
CDOUBLE_less_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        const double in2r = ((double *)ip2)[0];
        const double in2i = ((double *)ip2)[1];
        *((Bool *)op1) = CLE(in1r,in1i,in2r,in2i);
    }
}

#line 1120
static void
CDOUBLE_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        const double in2r = ((double *)ip2)[0];
        const double in2i = ((double *)ip2)[1];
        *((Bool *)op1) = CEQ(in1r,in1i,in2r,in2i);
    }
}

#line 1120
static void
CDOUBLE_not_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        const double in2r = ((double *)ip2)[0];
        const double in2i = ((double *)ip2)[1];
        *((Bool *)op1) = CNE(in1r,in1i,in2r,in2i);
    }
}


#line 1138
static void
CDOUBLE_logical_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        const double in2r = ((double *)ip2)[0];
        const double in2i = ((double *)ip2)[1];
        *((Bool *)op1) = (in1r || in1i) && (in2r || in2i);
    }
}

#line 1138
static void
CDOUBLE_logical_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        const double in2r = ((double *)ip2)[0];
        const double in2i = ((double *)ip2)[1];
        *((Bool *)op1) = (in1r || in1i) || (in2r || in2i);
    }
}


static void
CDOUBLE_logical_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        const double in2r = ((double *)ip2)[0];
        const double in2i = ((double *)ip2)[1];
        const Bool tmp1 = (in1r || in1i);
        const Bool tmp2 = (in2r || in2i);
        *((Bool *)op1) = (tmp1 && !tmp2) || (!tmp1 && tmp2);
    }
}

static void
CDOUBLE_logical_not(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        *((Bool *)op1) = !(in1r || in1i);
    }
}

#line 1180
static void
CDOUBLE_isnan(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        *((Bool *)op1) = npy_isnan(in1r) || npy_isnan(in1i);
    }
}

#line 1180
static void
CDOUBLE_isinf(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        *((Bool *)op1) = npy_isinf(in1r) || npy_isinf(in1i);
    }
}

#line 1180
static void
CDOUBLE_isfinite(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        *((Bool *)op1) = npy_isfinite(in1r) && npy_isfinite(in1i);
    }
}


static void
CDOUBLE_square(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        ((double *)op1)[0] = in1r*in1r - in1i*in1i;
        ((double *)op1)[1] = in1r*in1i + in1i*in1r;
    }
}

static void
CDOUBLE_reciprocal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        if (npy_fabs(in1i) <= npy_fabs(in1r)) {
            const double r = in1i/in1r;
            const double d = in1r + in1i*r;
            ((double *)op1)[0] = 1/d;
            ((double *)op1)[1] = -r/d;
        } else {
            const double r = in1r/in1i;
            const double d = in1r*r + in1i;
            ((double *)op1)[0] = r/d;
            ((double *)op1)[1] = -1/d;
        }
    }
}

static void
CDOUBLE_ones_like(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    OUTPUT_LOOP {
        ((double *)op1)[0] = 1;
        ((double *)op1)[1] = 0;
    }
}

static void
CDOUBLE_conjugate(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func)) {
    UNARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        ((double *)op1)[0] = in1r;
        ((double *)op1)[1] = -in1i;
    }
}

static void
CDOUBLE_absolute(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        *((double *)op1) = npy_sqrt(in1r*in1r + in1i*in1i);
    }
}

static void
CDOUBLE_sign(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    /* fixme: sign of nan is currently 0 */
    UNARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        ((double *)op1)[0] = CGT(in1r, in1i, 0, 0) ?  1 :
                            (CLT(in1r, in1i, 0, 0) ? -1 :
                            (CEQ(in1r, in1i, 0, 0) ?  0 : NPY_NAN));
        ((double *)op1)[1] = 0;
    }
}

#line 1269
static void
CDOUBLE_maximum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        const double in2r = ((double *)ip2)[0];
        const double in2i = ((double *)ip2)[1];
        if (CGE(in1r, in1i, in2r, in2i) || npy_isnan(in1r) || npy_isnan(in1i)) {
            ((double *)op1)[0] = in1r;
            ((double *)op1)[1] = in1i;
        }
        else {
            ((double *)op1)[0] = in2r;
            ((double *)op1)[1] = in2i;
        }
    }
}

#line 1269
static void
CDOUBLE_minimum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        const double in2r = ((double *)ip2)[0];
        const double in2i = ((double *)ip2)[1];
        if (CLE(in1r, in1i, in2r, in2i) || npy_isnan(in1r) || npy_isnan(in1i)) {
            ((double *)op1)[0] = in1r;
            ((double *)op1)[1] = in1i;
        }
        else {
            ((double *)op1)[0] = in2r;
            ((double *)op1)[1] = in2i;
        }
    }
}


#line 1293
static void
CDOUBLE_fmax(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        const double in2r = ((double *)ip2)[0];
        const double in2i = ((double *)ip2)[1];
        if (CGE(in1r, in1i, in2r, in2i) || npy_isnan(in2r) || npy_isnan(in2i)) {
            ((double *)op1)[0] = in1r;
            ((double *)op1)[1] = in1i;
        }
        else {
            ((double *)op1)[0] = in2r;
            ((double *)op1)[1] = in2i;
        }
    }
}

#line 1293
static void
CDOUBLE_fmin(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const double in1r = ((double *)ip1)[0];
        const double in1i = ((double *)ip1)[1];
        const double in2r = ((double *)ip2)[0];
        const double in2i = ((double *)ip2)[1];
        if (CLE(in1r, in1i, in2r, in2i) || npy_isnan(in2r) || npy_isnan(in2i)) {
            ((double *)op1)[0] = in1r;
            ((double *)op1)[1] = in1i;
        }
        else {
            ((double *)op1)[0] = in2r;
            ((double *)op1)[1] = in2i;
        }
    }
}


#define CDOUBLE_true_divide CDOUBLE_divide


#line 1055

#line 1061
static void
CLONGDOUBLE_add(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        const longdouble in2r = ((longdouble *)ip2)[0];
        const longdouble in2i = ((longdouble *)ip2)[1];
        ((longdouble *)op1)[0] = in1r + in2r;
        ((longdouble *)op1)[1] = in1i + in2i;
    }
}

#line 1061
static void
CLONGDOUBLE_subtract(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        const longdouble in2r = ((longdouble *)ip2)[0];
        const longdouble in2i = ((longdouble *)ip2)[1];
        ((longdouble *)op1)[0] = in1r - in2r;
        ((longdouble *)op1)[1] = in1i - in2i;
    }
}


static void
CLONGDOUBLE_multiply(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        const longdouble in2r = ((longdouble *)ip2)[0];
        const longdouble in2i = ((longdouble *)ip2)[1];
        ((longdouble *)op1)[0] = in1r*in2r - in1i*in2i;
        ((longdouble *)op1)[1] = in1r*in2i + in1i*in2r;
    }
}

static void
CLONGDOUBLE_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        const longdouble in2r = ((longdouble *)ip2)[0];
        const longdouble in2i = ((longdouble *)ip2)[1];
        longdouble d = in2r*in2r + in2i*in2i;
        ((longdouble *)op1)[0] = (in1r*in2r + in1i*in2i)/d;
        ((longdouble *)op1)[1] = (in1i*in2r - in1r*in2i)/d;
    }
}

static void
CLONGDOUBLE_floor_divide(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        const longdouble in2r = ((longdouble *)ip2)[0];
        const longdouble in2i = ((longdouble *)ip2)[1];
        longdouble d = in2r*in2r + in2i*in2i;
        ((longdouble *)op1)[0] = npy_floorl((in1r*in2r + in1i*in2i)/d);
        ((longdouble *)op1)[1] = 0;
    }
}

#line 1120
static void
CLONGDOUBLE_greater(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        const longdouble in2r = ((longdouble *)ip2)[0];
        const longdouble in2i = ((longdouble *)ip2)[1];
        *((Bool *)op1) = CGT(in1r,in1i,in2r,in2i);
    }
}

#line 1120
static void
CLONGDOUBLE_greater_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        const longdouble in2r = ((longdouble *)ip2)[0];
        const longdouble in2i = ((longdouble *)ip2)[1];
        *((Bool *)op1) = CGE(in1r,in1i,in2r,in2i);
    }
}

#line 1120
static void
CLONGDOUBLE_less(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        const longdouble in2r = ((longdouble *)ip2)[0];
        const longdouble in2i = ((longdouble *)ip2)[1];
        *((Bool *)op1) = CLT(in1r,in1i,in2r,in2i);
    }
}

#line 1120
static void
CLONGDOUBLE_less_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        const longdouble in2r = ((longdouble *)ip2)[0];
        const longdouble in2i = ((longdouble *)ip2)[1];
        *((Bool *)op1) = CLE(in1r,in1i,in2r,in2i);
    }
}

#line 1120
static void
CLONGDOUBLE_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        const longdouble in2r = ((longdouble *)ip2)[0];
        const longdouble in2i = ((longdouble *)ip2)[1];
        *((Bool *)op1) = CEQ(in1r,in1i,in2r,in2i);
    }
}

#line 1120
static void
CLONGDOUBLE_not_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        const longdouble in2r = ((longdouble *)ip2)[0];
        const longdouble in2i = ((longdouble *)ip2)[1];
        *((Bool *)op1) = CNE(in1r,in1i,in2r,in2i);
    }
}


#line 1138
static void
CLONGDOUBLE_logical_and(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        const longdouble in2r = ((longdouble *)ip2)[0];
        const longdouble in2i = ((longdouble *)ip2)[1];
        *((Bool *)op1) = (in1r || in1i) && (in2r || in2i);
    }
}

#line 1138
static void
CLONGDOUBLE_logical_or(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        const longdouble in2r = ((longdouble *)ip2)[0];
        const longdouble in2i = ((longdouble *)ip2)[1];
        *((Bool *)op1) = (in1r || in1i) || (in2r || in2i);
    }
}


static void
CLONGDOUBLE_logical_xor(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        const longdouble in2r = ((longdouble *)ip2)[0];
        const longdouble in2i = ((longdouble *)ip2)[1];
        const Bool tmp1 = (in1r || in1i);
        const Bool tmp2 = (in2r || in2i);
        *((Bool *)op1) = (tmp1 && !tmp2) || (!tmp1 && tmp2);
    }
}

static void
CLONGDOUBLE_logical_not(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        *((Bool *)op1) = !(in1r || in1i);
    }
}

#line 1180
static void
CLONGDOUBLE_isnan(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        *((Bool *)op1) = npy_isnan(in1r) || npy_isnan(in1i);
    }
}

#line 1180
static void
CLONGDOUBLE_isinf(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        *((Bool *)op1) = npy_isinf(in1r) || npy_isinf(in1i);
    }
}

#line 1180
static void
CLONGDOUBLE_isfinite(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        *((Bool *)op1) = npy_isfinite(in1r) && npy_isfinite(in1i);
    }
}


static void
CLONGDOUBLE_square(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        ((longdouble *)op1)[0] = in1r*in1r - in1i*in1i;
        ((longdouble *)op1)[1] = in1r*in1i + in1i*in1r;
    }
}

static void
CLONGDOUBLE_reciprocal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    UNARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        if (npy_fabsl(in1i) <= npy_fabsl(in1r)) {
            const longdouble r = in1i/in1r;
            const longdouble d = in1r + in1i*r;
            ((longdouble *)op1)[0] = 1/d;
            ((longdouble *)op1)[1] = -r/d;
        } else {
            const longdouble r = in1r/in1i;
            const longdouble d = in1r*r + in1i;
            ((longdouble *)op1)[0] = r/d;
            ((longdouble *)op1)[1] = -1/d;
        }
    }
}

static void
CLONGDOUBLE_ones_like(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(data))
{
    OUTPUT_LOOP {
        ((longdouble *)op1)[0] = 1;
        ((longdouble *)op1)[1] = 0;
    }
}

static void
CLONGDOUBLE_conjugate(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func)) {
    UNARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        ((longdouble *)op1)[0] = in1r;
        ((longdouble *)op1)[1] = -in1i;
    }
}

static void
CLONGDOUBLE_absolute(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    UNARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        *((longdouble *)op1) = npy_sqrtl(in1r*in1r + in1i*in1i);
    }
}

static void
CLONGDOUBLE_sign(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    /* fixme: sign of nan is currently 0 */
    UNARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        ((longdouble *)op1)[0] = CGT(in1r, in1i, 0, 0) ?  1 :
                            (CLT(in1r, in1i, 0, 0) ? -1 :
                            (CEQ(in1r, in1i, 0, 0) ?  0 : NPY_NANL));
        ((longdouble *)op1)[1] = 0;
    }
}

#line 1269
static void
CLONGDOUBLE_maximum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        const longdouble in2r = ((longdouble *)ip2)[0];
        const longdouble in2i = ((longdouble *)ip2)[1];
        if (CGE(in1r, in1i, in2r, in2i) || npy_isnan(in1r) || npy_isnan(in1i)) {
            ((longdouble *)op1)[0] = in1r;
            ((longdouble *)op1)[1] = in1i;
        }
        else {
            ((longdouble *)op1)[0] = in2r;
            ((longdouble *)op1)[1] = in2i;
        }
    }
}

#line 1269
static void
CLONGDOUBLE_minimum(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        const longdouble in2r = ((longdouble *)ip2)[0];
        const longdouble in2i = ((longdouble *)ip2)[1];
        if (CLE(in1r, in1i, in2r, in2i) || npy_isnan(in1r) || npy_isnan(in1i)) {
            ((longdouble *)op1)[0] = in1r;
            ((longdouble *)op1)[1] = in1i;
        }
        else {
            ((longdouble *)op1)[0] = in2r;
            ((longdouble *)op1)[1] = in2i;
        }
    }
}


#line 1293
static void
CLONGDOUBLE_fmax(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        const longdouble in2r = ((longdouble *)ip2)[0];
        const longdouble in2i = ((longdouble *)ip2)[1];
        if (CGE(in1r, in1i, in2r, in2i) || npy_isnan(in2r) || npy_isnan(in2i)) {
            ((longdouble *)op1)[0] = in1r;
            ((longdouble *)op1)[1] = in1i;
        }
        else {
            ((longdouble *)op1)[0] = in2r;
            ((longdouble *)op1)[1] = in2i;
        }
    }
}

#line 1293
static void
CLONGDOUBLE_fmin(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    BINARY_LOOP {
        const longdouble in1r = ((longdouble *)ip1)[0];
        const longdouble in1i = ((longdouble *)ip1)[1];
        const longdouble in2r = ((longdouble *)ip2)[0];
        const longdouble in2i = ((longdouble *)ip2)[1];
        if (CLE(in1r, in1i, in2r, in2i) || npy_isnan(in2r) || npy_isnan(in2i)) {
            ((longdouble *)op1)[0] = in1r;
            ((longdouble *)op1)[1] = in1i;
        }
        else {
            ((longdouble *)op1)[0] = in2r;
            ((longdouble *)op1)[1] = in2i;
        }
    }
}


#define CLONGDOUBLE_true_divide CLONGDOUBLE_divide



#undef CGE
#undef CLE
#undef CGT
#undef CLT
#undef CEQ
#undef CNE

/*
 *****************************************************************************
 **                            OBJECT LOOPS                                 **
 *****************************************************************************
 */

#line 1334
static void
OBJECT_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func)) {
    BINARY_LOOP {
        PyObject *in1 = *(PyObject **)ip1;
        PyObject *in2 = *(PyObject **)ip2;
        int ret = PyObject_RichCompareBool(in1, in2, Py_EQ);
        if (ret == -1) {
            return;
        }
        *((Bool *)op1) = (Bool)ret;
    }
}

#line 1334
static void
OBJECT_not_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func)) {
    BINARY_LOOP {
        PyObject *in1 = *(PyObject **)ip1;
        PyObject *in2 = *(PyObject **)ip2;
        int ret = PyObject_RichCompareBool(in1, in2, Py_NE);
        if (ret == -1) {
            return;
        }
        *((Bool *)op1) = (Bool)ret;
    }
}

#line 1334
static void
OBJECT_greater(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func)) {
    BINARY_LOOP {
        PyObject *in1 = *(PyObject **)ip1;
        PyObject *in2 = *(PyObject **)ip2;
        int ret = PyObject_RichCompareBool(in1, in2, Py_GT);
        if (ret == -1) {
            return;
        }
        *((Bool *)op1) = (Bool)ret;
    }
}

#line 1334
static void
OBJECT_greater_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func)) {
    BINARY_LOOP {
        PyObject *in1 = *(PyObject **)ip1;
        PyObject *in2 = *(PyObject **)ip2;
        int ret = PyObject_RichCompareBool(in1, in2, Py_GE);
        if (ret == -1) {
            return;
        }
        *((Bool *)op1) = (Bool)ret;
    }
}

#line 1334
static void
OBJECT_less(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func)) {
    BINARY_LOOP {
        PyObject *in1 = *(PyObject **)ip1;
        PyObject *in2 = *(PyObject **)ip2;
        int ret = PyObject_RichCompareBool(in1, in2, Py_LT);
        if (ret == -1) {
            return;
        }
        *((Bool *)op1) = (Bool)ret;
    }
}

#line 1334
static void
OBJECT_less_equal(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func)) {
    BINARY_LOOP {
        PyObject *in1 = *(PyObject **)ip1;
        PyObject *in2 = *(PyObject **)ip2;
        int ret = PyObject_RichCompareBool(in1, in2, Py_LE);
        if (ret == -1) {
            return;
        }
        *((Bool *)op1) = (Bool)ret;
    }
}


static void
OBJECT_sign(char **args, intp *dimensions, intp *steps, void *NPY_UNUSED(func))
{
    PyObject *zero = PyInt_FromLong(0);
    UNARY_LOOP {
        PyObject *in1 = *(PyObject **)ip1;
        PyObject **out = (PyObject **)op1;
        PyObject *ret = PyInt_FromLong(PyObject_Compare(in1, zero));
        if (PyErr_Occurred()) {
            return;
        }
        Py_XDECREF(*out);
        *out = ret;
    }
    Py_DECREF(zero);
}

/*
 *****************************************************************************
 **                              END LOOPS                                  **
 *****************************************************************************
 */



